local VEHICLE_MAX_OVERLAY = 4;
local VEHICLE_MAX_ARTWORK = 10;
local VEHICLE_MAX_BORDER = 7;
local VEHICLE_MAX_BACKGROUND = 3;
local vehiclescale = 0.75;
local Semiclass = UnitClass("player");
local Semilevel = UnitLevel("player");
local SemiMaxLevel = MAX_PLAYER_LEVEL;
local SemiMicroMoved;

local SemiMicroMenuButtons = {			--12 Buttons
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	LFDMicroButton,
	EJMicroButton,
	CollectionsMicroButton,
	MainMenuMicroButton,
	HelpMicroButton,
	StoreMicroButton	
}


function Semi_LinkMainMenuBarToDragButton()

 if (not InCombatLockdown()) then
	Semi_MainMenu_Bar:ClearAllPoints();
	Semi_MainMenu_Bar:SetPoint("BOTTOM", Semi_MainMenu_BarActionBarDragButton, "BOTTOM");
 end
end

--stance bar 
function SemiStanceBar_HideStanceArt()
	StanceBarLeft:SetAlpha(0);
	StanceBarMiddle:SetAlpha(0);
	StanceBarRight:SetAlpha(0);
	SlidingActionBarTexture0:SetAlpha(0);
	SlidingActionBarTexture1:SetAlpha(0);
end

function Semi_Link_Stance_BarToDragButton()
	if (not InCombatLockdown()) then
		_G["StanceBarFrame"].ignoreFramePositionManager = true;
		StanceBarFrame:ClearAllPoints();
		StanceBarFrame:SetPoint("BOTTOMLEFT", SemiStanceBarDragButton, "TOPRIGHT");
		StanceButton1:ClearAllPoints();
		StanceButton1:SetPoint("LEFT", StanceBarFrame, "LEFT");
		if Semi_LockDownButtonFrame:IsVisible() then
			SemiStanceBarDragButton:Show();
		else
			SemiStanceBarDragButton:Hide();
		end
	end
end

-- Pet Bar
function SemiPetBar_HidePetArt()
	PetActionBarFrame:EnableMouse(false);
	SlidingActionBarTexture0:SetAlpha(0);
	SlidingActionBarTexture1:SetAlpha(0);
end

function Semi_Construct_Pet_Bar()
	for i=1, 10 do
		pet_button = _G["PetActionButton"..i];
		if (pet_button ~= nil) then
			pet_button:ClearAllPoints();
			x_coord = 0 + ((i - 1) * 38);
			y_coord = 0;
			pet_button:SetPoint("BOTTOMLEFT", SemiPetBar, "BOTTOMLEFT", x_coord, y_coord);
		end
	end
end

function Semi_Link_Pet_BarToDragButton()
	SemiPetBar:ClearAllPoints();
	SemiPetBar:SetPoint("BOTTOMLEFT", SemiPetBarDragButton, "TOPRIGHT");
	
	if Semi_LockDownButtonFrame:IsVisible() then
		SemiPetBarDragButton:Show();
	else
		SemiPetBarDragButton:Hide();
	end
	SetPetBarScale(Semi_PetBar_Scale);	
end

-- Vehicle Action Bar 
function Semi_LinkPossessBarFrameToDragButton()
	UIPARENT_MANAGED_FRAME_POSITIONS["PossessBarFrame"] = nil;
	PossessBarFrame:ClearAllPoints();
	PossessBarFrame:SetPoint("BOTTOMLEFT", SemiPossessBarFrameDragButton, "BOTTOMLEFT");
	SemiPossessBarFrameDragButtonText:SetText(Semi_PossessBar_Drag_Text);
end

function Semi_LinkOverrideActionBarToDragButton()
	OverrideActionBar:ClearAllPoints();
	OverrideActionBar:SetPoint("BOTTOM", SemiOverrideActionBarDragButton, "BOTTOM");
end

-- Bottom left actionbar
function Semi_LinkBottomLeftBarToDragButton()
	if (not InCombatLockdown()) then
		if Semi_AB_BL_State then
			Semi_BottomLeft_Bar:Show();
			--Semi_BottomLeft_Bar:EnableMouse(true);
		end
		Semi_BottomLeft_Bar:ClearAllPoints();
		Semi_BottomLeft_Bar:SetPoint("BOTTOM", Semi_BottomLeft_BarActionBarDragButton, "BOTTOM");
	end
end

-- Bottom right actionbar
function Semi_LinkBottomRightBarToDragButton()
	if (not InCombatLockdown()) then
		Semi_BottomRight_Bar:ClearAllPoints();
		Semi_BottomRight_Bar:SetPoint("BOTTOM", Semi_BottomRight_BarActionBarDragButton, "BOTTOM");
		
		if Semi_AB_BR_State then
			Semi_BottomRight_Bar:Show();
			--Semi_BottomRight_Bar:EnableMouse(true);
		end
		
	end
end

--TODO-- Create my own buttons that open/active the micromenu buttons
-- Move the micro menu buttons
function Semi_LinkMicroMenuToDragButton()
	if (not InCombatLockdown()) then
		if (CharacterMicroButton:GetParent():GetName() == "MainMenuBarArtFrame") then
			CharacterMicroButton:ClearAllPoints();
			CharacterMicroButton:SetPoint("BOTTOMLEFT", SemiMicroMenuDragButton, "BOTTOMLEFT");
			SemiMicroMoved = false; -- This is reset back to false, since micro menu is back where it belongs and we are out of combat
		elseif (CharacterMicroButton:GetParent():GetName() == "OverrideActionBar") or (CharacterMicroButton:GetParent():GetName() == "PetBattleFrame") then
			for i=1,12 do 
				SemiMicroMenuButtons[i]:SetScale(1);
			end
		end
	elseif (InCombatLockdown()) then --and (CharacterMicroButton:GetParent():GetName() ~= "MainMenuBarArtFrame") then
			SemiMicroMoved = true;  -- this means the hook moved the micromenu while in combat
									-- we need to tell my mod to call this function after combat to re-anchor it properly, in Semi_UpdateBarPositions()
	end   --MoveMicroButtons can fire and not move it away from main menu bar, this can happen with full screen map opening and closing.
		--micro buttons simple stay where they are, whether it is main menu bar or override bar or petbattleframe
end
hooksecurefunc("MoveMicroButtons", Semi_LinkMicroMenuToDragButton);
--- this is called everytime by mainmenubar via it's "OnShow" tag, so this can be called after the exit of full screen map while in combat


-- Move the bags
function Semi_LinkInventoryBagsToDragButton()
		MainMenuBarBackpackButton:ClearAllPoints();
		MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", SemiInventoryBagsDragButton, "BOTTOMRIGHT");
		MainMenuBarBackpackButton:SetMovable(true);
		MainMenuBarBackpackButton:SetUserPlaced(true);
end

function ShowSemiBags()
	MainMenuBarBackpackButton:Show();
	CharacterBag0Slot:Show();
	CharacterBag1Slot:Show();
	CharacterBag2Slot:Show();
	CharacterBag3Slot:Show();
	Semi_LinkInventoryBagsToDragButton();
end

function HideSemiBags()
	MainMenuBarBackpackButton:Hide();
	CharacterBag0Slot:Hide();
	CharacterBag1Slot:Hide();
	CharacterBag2Slot:Hide();
	CharacterBag3Slot:Hide();
end

function ShowSemiMenu()

	for i=1,12 do
		SemiMicroMenuButtons[i]:SetAlpha(1);
		SemiMicroMenuButtons[i]:EnableMouse(true);
	end
	Semi_LinkMicroMenuToDragButton();
end

function HideSemiMenu()

	for i=1,12 do
		SemiMicroMenuButtons[i]:SetAlpha(0);
		SemiMicroMenuButtons[i]:EnableMouse(false);
	end
end

function SemiActionBars_OnEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 = ...;

   	if (event=="ADDON_LOADED" and arg1=="Semi_Action_Bars") or (event=="PLAYER_ENTERING_WORLD" or event=="PLAYER_LOGIN" and IsAddOnLoaded("Semi_Action_Bars")) then
		
		if Semi_AB_Main_State then 
			MainMenuBar:ClearAllPoints();
			MainMenuBar:SetPoint("TOP", UIParent, "BOTTOM", 0, -500);
			MainMenuBar:SetMovable(true);
			MainMenuBar:SetUserPlaced(true);		
		end
		MicroButtonAndBagsBar.MicroBagBar:Hide(); --turn this into an option later
	
		Semi_MainMenu_BarActionBarDragButton:Hide();
		SemiOverrideActionBarDragButton:Hide();
		Semi_BottomLeft_BarActionBarDragButton:Hide();
		Semi_BottomRight_BarActionBarDragButton:Hide();
		SemiMicroMenuDragButton:Hide();
		SemiInventoryBagsDragButton:Hide();
		SemiPossessBarFrameDragButton:Hide();
		SemiStanceBarDragButton:Hide();
		SemiStanceBar_HideStanceArt();
		SemiPetBarDragButton:Hide();
		
		SemiPetBar_HidePetArt();
		
		if (SF_MicroMenu_State) then
			ShowSemiMenu();
		elseif (not SF_MicroMenu_State) then
				HideSemiMenu();
		end
		if (SF_Bags_State) then
			ShowSemiBags();
		elseif (not SF_Bags_State) then
			HideSemiBags();
		end
		SetMenuBarScale(Semi_AllBars_Scale);
		Semi_LinkMicroMenuToDragButton();
		Semi_LinkInventoryBagsToDragButton();
		
		
		Semi_UpdateBarPositions();
	end
	
	if (event == "PLAYER_LOGIN" or event == "PLAYER_ENTERING_WORLD") and IsAddOnLoaded("Semi_Action_Bars") then
		
		local currState;
		if HasVehicleActionBar() then
			currState = GetVehicleBarIndex()
		elseif HasOverrideActionBar() then
			currState = GetOverrideBarIndex()
		elseif HasTempShapeshiftActionBar() then
			currState = GetTempShapeshiftBarIndex()
		elseif GetBonusBarOffset() > 0 then
			currState = GetBonusBarOffset() + 6
		else
			currState = GetActionBarPage()
		end
		
		Semi_MainMenu_Bar:SetAttribute("actionpage", currState)
		--following is required for the state driver of the bar to set an attribute when the bar changes
		--thus forcing the blizzard ActionBarButtonTemplate’s Handler to refresh the buttons without needing
		--to mouseover "enter" the frame of each button
		for i=1,12 do
			_G["Semi_MainMenu_BarButton"..i]:SetAttribute("touch", currstate)
		end
		
		local newstate;
		conditionBase, driver = '[%s] %d; ', ''
		local conditions = {'bar:2', 'bar:3', 'bar:4', 'bar:5', 'bar:6', 'vehicleui', 'possessbar', 'overridebar', 'shapeshift', 'bonusbar:1', 'bonusbar:2', 'bonusbar:3', 'bonusbar:4'}
		for i, macroCondition in ipairs(conditions) do
			driver = driver .. conditionBase:format(macroCondition, i)
		end
    ----------------------------------
    -- append the list for the default bar (1) when none of the conditions apply.
		driver = driver .. (#conditions + 1)
		RegisterStateDriver(Semi_MainMenu_Bar, "page", driver)
		
		Semi_MainMenu_Bar:SetAttribute("_onstate-page", [[
			if HasVehicleActionBar() then
				newstate = GetVehicleBarIndex()
			elseif HasOverrideActionBar() then
				newstate = GetOverrideBarIndex()
			elseif HasTempShapeshiftActionBar() then
				newstate = GetTempShapeshiftBarIndex()
			elseif GetBonusBarOffset() > 0 then
				newstate = GetBonusBarOffset() + 6
			else
				newstate = GetActionBarPage()
			end
			self:SetAttribute('actionpage', newstate)
			buttons = table.new(self:GetChildren())
			for i, button in ipairs(buttons) do
				button:SetAttribute("touch",newstate)				
			end
			]]);
		
		
		Semi_Bar_StateDriver("Semi_MainMenu_Bar", Semi_AB_Main_State, Semi_AB_Vehicle);
		Semi_Bar_StateDriver("Semi_BottomLeft_Bar", Semi_AB_BL_State, Semi_AB_Vehicle);
		Semi_Bar_StateDriver("Semi_BottomRight_Bar", Semi_AB_BR_State, Semi_AB_Vehicle);

		for i=1, 12 do
			_G["Semi_BottomLeft_BarButton"..i.."FloatingBG"]:SetAlpha(0);
			_G["Semi_BottomRight_BarButton"..i.."FloatingBG"]:SetAlpha(0);
		end
		
	end

	if ( event == "UPDATE_SHAPESHIFT_COOLDOWN" ) then
		SemiStanceBar_HideStanceArt();
		Semi_Link_Stance_BarToDragButton();
	end
	if (event == "PLAYER_REGEN_ENABLED") and SemiMicroMoved then
		Semi_LinkMicroMenuToDragButton();
	end
end

--[[
function SemiUpdateMainButtons()
	local menulist = {
		ActionButton1,
		ActionButton2,
		ActionButton3,
		ActionButton4,
		ActionButton5,
		ActionButton6,
		ActionButton7,
		ActionButton8,
		ActionButton9,
		ActionButton10,
		ActionButton11,
		ActionButton12
		};
		
	for i=1,12 do
			local sself = _G["Semi_MainMenu_BarButton"..i]
			--print("button is now: ",button)
			local texture = (GetActionTexture(menulist[i].action));
			--local Shine = menulist[i].Shine
				
			
			
			-- Update Action Text
			--
			local actionName = menulist[i].Name;
			if actionName then
				if ( not IsConsumableAction(menulist[i].action) and not IsStackableAction(menulist[i].action) and (IsItemAction(menulist[i].action) or GetActionCount(menulist[i].action) == 0) ) then
					sself.Name:SetText(GetActionText(menulist[i].action));
					--sself.cooldown = menulist[i].cooldown;
				else
					sself.Name:SetText("");
				end
				--sself.cooldown = menulist[i].cooldown;
			end
			--
			if texture then
				--print("ActionButton1 - ",texture);
				--_G[button].icon:SetTexture(texture);
				sself.icon:SetTexture(texture);
				sself.icon:Show();
				sself.rangeTimer = -1;
				sself:UpdateCount();
				--SetActionUIButton(sself, menulist[i].action, menulist[i].cooldown); -- this fails... :-(
				
				--test removal begin -- 12-7-2021

				local isUsable, notEnoughMana = IsUsableAction(menulist[i].action);
				if ( isUsable ) then
					sself.icon:SetVertexColor(1.0, 1.0, 1.0);
					sself.NormalTexture:SetVertexColor(1.0, 1.0, 1.0);
				elseif ( notEnoughMana ) then
					sself.icon:SetVertexColor(0.5, 0.5, 1.0);
					sself.NormalTexture:SetVertexColor(0.5, 0.5, 1.0);
				else
					sself.icon:SetVertexColor(0.4, 0.4, 0.4);
					sself.NormalTexture:SetVertexColor(1.0, 1.0, 1.0);
				end

				local isLevelLinkLocked = C_LevelLink.IsActionLocked(menulist[i].action);
				if not menulist[i].icon:IsDesaturated() then
					sself.icon:SetDesaturated(isLevelLinkLocked);
				end

				if menulist[i].LevelLinkLockIcon then
					sself.LevelLinkLockIcon:SetShown(isLevelLinkLocked);
				end
				--test removal end -- 12-7-2021	-results...need to keep this 
				
				--sself:Update();
				--sself.cooldown:Show();
			else
				--print("ActionButton1 - No Texture");
				--_G[button].icon:Hide();
				sself.icon:Hide();
				sself.Count:SetText("");
				sself.icon:Hide();
				sself.cooldown:Hide();
				sself.rangeTimer = nil;
			end
			
			local hotkey = menulist[i].HotKey;
			if ( hotkey:GetText() == RANGE_INDICATOR ) then
				sself.HotKey:Hide();
			else
				sself.HotKey:SetVertexColor(0.6, 0.6, 0.6);
				sself.HotKey:SetText(hotkey:GetText())
				sself.HotKey:Show();
			end
		
	end
end
--hooksecurefunc("UIParent_ManageFramePositions", SemiUpdateMainButtons)
--previous function and hook no longer needed with the proper use of the "touch" attribute
--]]
--[[
function SetMenuBarScale(scale)
	Semi_MainMenu_Bar:SetScale(scale);
	Semi_MainMenu_BarActionBarDragButton:SetScale(scale);
	Semi_BottomRight_Bar:SetScale(scale);
	Semi_BottomRight_BarActionBarDragButton:SetScale(scale);
	Semi_BottomLeft_Bar:SetScale(scale);
	Semi_BottomLeft_BarActionBarDragButton:SetScale(scale);
end
--]]
local frame = CreateFrame("Frame", "Semi_MyAddOnFrame");
frame:SetScript("OnEvent", SemiActionBars_OnEvent);
frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("PLAYER_LOGIN");
frame:RegisterEvent("PLAYER_REGEN_ENABLED");
frame:RegisterEvent("UPDATE_SHAPESHIFT_COOLDOWN");

function Semi_UpdateBarPositions()

	if (not InCombatLockdown()) then 
		
		if (SF_MicroMenu_State) then 
			ShowSemiMenu();
		else
			HideSemiMenu();
		end
		if (SF_Bags_State) then 
			ShowSemiBags();
		else
			HideSemiBags();
		end
		Semi_LinkMainMenuBarToDragButton();
		Semi_LinkPossessBarFrameToDragButton();
		Semi_LinkMicroMenuToDragButton();  --here we are moving the micro menu back where it belongs after combat
		Semi_LinkInventoryBagsToDragButton();
		Semi_MainMenuBarGridChoice(); --might not need this
	end
	-- added check for temp variable that will be true if micro menu got moved while in combat, yet moved back to
	-- mainmenubarartframe while still in combat and never got the chance to get anchored back to my drag button
	
	if (not InCombatLockdown()) and (SemiMicroMoved) then
		Semi_LinkMicroMenuToDragButton();
		--I swear we are gonna anchor that damm thing down, even if it drives me insane.
	end
		
end

function Semi_MainMenuBarGridChoice()
	if (not InCombatLockdown()) then
		local showInt = 0;
		if (SF_MainMenuBarGrid_State) then
			showInt = 1;
		end
		local semibuttons = {
			"Semi_MainMenu_BarButton",
			"Semi_BottomLeft_BarButton",
			"Semi_BottomRight_BarButton"
			};
		for j=1,3 do
			for i=1, 12 do
				local gridbutton = _G[semibuttons[j]..i];
					gridbutton:SetAttribute("showgrid", showInt);
					gridbutton:ShowGrid(ACTION_BUTTON_SHOW_GRID_REASON_CVAR);
			end
		end
	 end
end
	
	--test to remove taint--
	UIPARENT_MANAGED_FRAME_POSITIONS["MultiCastActionBarFrame"] = nil;
