--Handle AlwaysUpFrame1 and AlwaysUpFrame2..?
--
SF_MiniMapChoice_Load = true;
SF_Castbar_Ownership = true;
SF_AchievementFrame_Ownership = true;
SF_Castbar_State = true;
SF_Gryphon_State = true;
SF_XP_Bar_State = true;
SF_Vehicle_Art_State = true;
SF_Bags_State = true;
SF_MicroMenu_State = true;
SF_MainMenuBarGrid_State = true;
SF_EB_1_State = true;
SF_EB_2_State = true;
SF_EB_3_State = true;
SF_EB_4_State = true; 
SF_EB_Vert_1_State = false;
SF_EB_Vert_2_State = false;
Semi_EB_Grid = true;
Semi_AB_Main_State = true;
Semi_AB_BL_State = true;
Semi_AB_BR_State = true;
Semi_AB_Vehicle = false;
Semi_EB_Vehicle = false;
Semi_Player_Scale = 1.0;
Semi_RuneFrame_Scale = 1.0;
Semi_Pet_Scale = 1.0;
Semi_Target_Scale = 1.0;
Semi_ToT_Scale = 1.0;
Semi_AllBars_Scale = 1.0;
Semi_MicroMenuButtons_Scale = 1.0;
Semi_VehicleBar_Scale = 0.75;
Semi_PetBattleFrame_Scale = 0.8;
Semi_PetBar_Scale = 1.0;
Semi_Support_PlayerXPBar_Scale = 1.0;
Semi_PartyFrame_Scale = 1.0;
Semi_FocusFrame_Scale = 1.0;
Semi_BossTargetFrame_Scale = 1.0;
Semi_GroupLootFrame_Scale = 1.0;
Semi_FrameNames_Scale = 1.0;
Semi_CollectionsJournal_Scale = 1.0;
Semi_CalendarFrame_Scale = 1.0;
Semi_WorldMapFrame_Scale = 1.0;
Semi_Objective_Frame_Height = 500;
Semi_ObjectiveFrame_Scale = 1;
Semi_MinimapCluster_Scale = 1;
Semi_MapFarm = false;
Semi_BagReset_State = false;

BACKDROP_SEMI_16 = {
   bgFile = "SemiBackground.tga",
   edgeFile = nil,
   tile = true,
   tileSize = 32,
   insets = { left = 5, right = 5, top = 5, bottom = 5 }
}

--]]
local Semiclass = UnitClass("player");
local Semilevel = UnitLevel("player");
local Semirealm = GetRealmName();
local Semichar = UnitName("player");
local Semi_LinkHeadNow = false;
local Semi_LinkAbilityNow = true;

local SemiMaxLevel = MAX_PLAYER_LEVEL;
local SemiMicroMenuButtons = {			
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	LFDMicroButton,
	EJMicroButton,
	CollectionsMicroButton,
	MainMenuMicroButton,
	HelpMicroButton,
	StoreMicroButton
}

local Semi_Vehicle_Texture = {
	OverrideActionBarBG,		--16 items to hide
	OverrideActionBarEndCapL,
	OverrideActionBarEndCapR,
	OverrideActionBarPowerBarOverlay,
	OverrideActionBarHealthBarOverlay,
	OverrideActionBarMicroBGL,
	OverrideActionBarMicroBGR,
	OverrideActionBarMicroBGMid,
	OverrideActionBarBorder,
	OverrideActionBarButtonBGL,
	OverrideActionBarButtonBGR,
	OverrideActionBarButtonBGMid,
	OverrideActionBar.Divider1,
	OverrideActionBar.Divider2,
	OverrideActionBar.Divider3,
	OverrideActionBar.ExitBG
};

function Semi_Core_OnLoad()
		--Setting Inital Text for Menu
	Semi_CoreOptionsTitle:SetText(Semi_Core_String_Version);
	if (SF_Bags_State) then
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
	elseif (not SF_Bags_State) then
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
	end
	if (SF_MicroMenu_State) then
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
	elseif (not SF_MicroMenu_State) then
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
	end
	
	if (Semi_AB_Vehicle) then
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12a);
	else
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12b);
	end
	
	if (Semi_AB_Main_State) then
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13a);
	else
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13b);
	end
	
	if (SF_MainMenuBarGrid_State) then
		Semi_CoreOptionsCheckButton16Text:SetText(Semi_Core_String_CB16a);
	else
		Semi_CoreOptionsCheckButton16Text:SetText(Semi_Core_String_CB16b);
	end
	
	if (Semi_BagReset_State) then
		Semi_CoreOptionsCheckButton23Text:SetText(Semi_Core_String_CB23a);
	else
		Semi_CoreOptionsCheckButton23Text:SetText(Semi_Core_String_CB23b);
	end
	
	if (Semi_MapFarm) then
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
	else
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
	end
	
	if (SF_Castbar_Ownership) then
		Semi_CoreOptionsCheckButton18Text:SetText(Semi_Core_String_CB18a);
		if (SF_Castbar_State) then
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
		elseif (not SF_Castbar_State) then
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
		end
	elseif (not SF_Castbar_Ownership) then
		Semi_CoreOptionsCheckButton18Text:SetText(Semi_Core_String_CB18b);
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4c);
	end
	
	if (SF_AchievementFrame_Ownership) then
		Semi_CoreOptionsCheckButton19Text:SetText(Semi_Core_String_CB19a);
	elseif (not SF_AchievementFrame_Ownership) then
		Semi_CoreOptionsCheckButton19Text:SetText(Semi_Core_String_CB19b);
	end
	
	if (SF_Vehicle_Art_State) then
		Semi_CoreOptionsCheckButton20Text:SetText(Semi_Core_String_CB20a);
	elseif (not SF_Vehicle_Art_State) then
		Semi_CoreOptionsCheckButton20Text:SetText(Semi_Core_String_CB20b);
	end
	
	if (SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	elseif (not SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
	
	if (SF_XP_Bar_State) then
		Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17a);
	elseif (not SF_XP_Bar_State) then
		Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17b);
	end
	Semi_CoreOptionsButton1:SetText(Semi_Core_String_B1);
	
		--Setting Inital Text for Modules Menu
	Semi_CoreOptions_ModsTitle:SetText(Semi_Core_Mods_String_Title);
	Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9a);
	Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10a);
	Semi_CoreOptions_ModsButton1:SetText(Semi_Core_Mods_String_B1);
end

function Semi_CoreOptions_OnLoad(self)
	panel = Semi_CoreOptions;	
	panel.name = "Main Menu";
	panel.parent = "Semi";
	
	self:SetBackdrop(BACKDROP_SEMI_16);
	BackdropTemplateMixin.OnBackdropLoaded(self);
	self:SetBackdropColor(0,0,0,1);
	InterfaceOptions_AddCategory(panel);
end

function Semi_InterfaceParent_Frame_OnLoad(self)
	panel = Semi_InterfaceParent_Frame;
	panel.name = "Semi";
	Semi_InterfaceParent_FrameTitle:SetText("|cffffffffSemi");
	Semi_InterfaceParent_FrameInfo:SetText(Semi_Interface_Info_Text);
	Semi_InterfaceParent_FrameInfo2:SetText(Semi_Interface_Info2_Text);
	Semi_InterfaceParent_FrameButtonSaveGlobalText:SetText(Semi_Core_String_B3);
	Semi_InterfaceParent_FrameButtonLoadGlobalText:SetText(Semi_Core_String_B4);
	Semi_InterfaceParent_FrameButtonSaveGlobalFramesText:SetText(Semi_Core_String_B5);
	Semi_InterfaceParent_FrameButtonLoadGlobalFramesText:SetText(Semi_Core_String_B6);
	Semi_InterfaceParent_FrameButtonSaveClassFramesText:SetText(Semi_Core_String_B7);
	Semi_InterfaceParent_FrameButtonLoadClassFramesText:SetText(Semi_Core_String_B8);
	
	self:SetBackdrop(BACKDROP_SEMI_16);
	BackdropTemplateMixin.OnBackdropLoaded(self);
	self:SetBackdropColor(0,0,0,1);
	
	if SF_MiniMapChoice_Load then
		Semi_InterfaceParent_FrameCheckButtonMiniMapChoiceText:SetText(Semi_MiniMap_Choice_Yes);
		
	elseif (not SF_MiniMapChoice_Load) then
		Semi_InterfaceParent_FrameCheckButtonMiniMapChoiceText:SetText(Semi_MiniMap_Choice_No);
	end
	
	InterfaceOptions_AddCategory(panel);
end

function Semi_InterfaceParent_Frame_OnShow(self)
	Semi_InterfaceParent_FrameCheckButtonMiniMapChoice:SetChecked(SF_MiniMapChoice_Load);
	if (not IsAddOnLoaded("Semi_Extra_Scaling")) then
		_G[self:GetName().."Info2"]:SetText("");
	end
	

end

function Semi_CoreOptions_OnShow(self)
	if (IsAddOnLoaded("Semi_Action_Bars")) then
		if (SF_Bags_State) then
			Semi_CoreOptionsCheckButton1:SetChecked(true);
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
		else 
			Semi_CoreOptionsCheckButton1:SetChecked(false);
			Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
		end
		if (SF_MicroMenu_State) then
			Semi_CoreOptionsCheckButton2:SetChecked(true);
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
		else 
			Semi_CoreOptionsCheckButton2:SetChecked(false);
			Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
		end
		--[[
		Semi_CoreOptionsCheckButton5:Disable();
		Semi_CoreOptionsCheckButton5:Hide();
		Semi_CoreOptionsCheckButton17:Disable();
		Semi_CoreOptionsCheckButton17:Hide();
		--]]
		
		if (Semi_AB_Vehicle) then
			Semi_CoreOptionsCheckButton12:SetChecked(true);
			Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12a);
		else
			Semi_CoreOptionsCheckButton12:SetChecked(false);
			Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12b);
		end

		if (Semi_AB_Main_State) then
			Semi_CoreOptionsCheckButton13:SetChecked(true);
			Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13a);
		else 
			Semi_CoreOptionsCheckButton13:SetChecked(false);
			Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13b);
		end
		
		if (SF_MainMenuBarGrid_State) then
			Semi_CoreOptionsCheckButton16:SetChecked(true);
			Semi_CoreOptionsCheckButton16Text:SetText(Semi_Core_String_CB16a);
		else 
			Semi_CoreOptionsCheckButton16:SetChecked(false);
			Semi_CoreOptionsCheckButton16Text:SetText(Semi_Core_String_CB16b);
		end
		if (Semi_AB_BL_State) then
			Semi_CoreOptionsCheckButton_AB_BottomLeft:SetChecked(true);
			Semi_CoreOptionsCheckButton_AB_BottomLeftText:SetText(Semi_Core_String_CB21a);
		else 
			Semi_CoreOptionsCheckButton_AB_BottomLeft:SetChecked(false);
			Semi_CoreOptionsCheckButton_AB_BottomLeftText:SetText(Semi_Core_String_CB21b);
			if (not Semi_AB_Main_State) then
				Semi_CoreOptionsCheckButton_AB_BottomLeft:Disable();
			end
		end
		if (Semi_AB_BR_State) then
			Semi_CoreOptionsCheckButton_AB_BottomRight:SetChecked(true);
			Semi_CoreOptionsCheckButton_AB_BottomRightText:SetText(Semi_Core_String_CB22a);
		else
			Semi_CoreOptionsCheckButton_AB_BottomRight:SetChecked(false);
			Semi_CoreOptionsCheckButton_AB_BottomRightText:SetText(Semi_Core_String_CB22b);
			if (not Semi_AB_Main_State) then
				Semi_CoreOptionsCheckButton_AB_BottomRight:Disable();
			end
		end
	end

	
	
	
	if Semi_BagReset_State then
		Semi_CoreOptionsCheckButton23:SetChecked(true);
		Semi_CoreOptionsCheckButton23Text:SetText(Semi_Core_String_CB23a);
	else
		Semi_CoreOptionsCheckButton23:SetChecked(false);
		Semi_CoreOptionsCheckButton23Text:SetText(Semi_Core_String_CB23b);
	end

	if Semi_MapFarm then
		Semi_CoreOptionsCheckButton3:SetChecked(true);
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a);
	else
		Semi_CoreOptionsCheckButton3:SetChecked(false);
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b);
	end
	
	--[[
	--New features will be implemented and take over these checkboxes.
	Semi_CoreOptionsCheckButton11:SetChecked(false);
	Semi_CoreOptionsCheckButton11Text:SetText(" ");
	Semi_CoreOptionsCheckButton11:Disable();
	Semi_CoreOptionsCheckButton11:Hide();
	--]]
	if (not IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_CoreOptionsCheckButton1:Disable();
			Semi_CoreOptionsCheckButton1:Hide();
			Semi_CoreOptionsCheckButton2:Disable();
			Semi_CoreOptionsCheckButton2:Hide();
			Semi_CoreOptionsCheckButton12:Disable();
			Semi_CoreOptionsCheckButton12:Hide();
			Semi_CoreOptionsCheckButton16:Disable();
			Semi_CoreOptionsCheckButton16:Hide();
			
			Semi_CoreOptionsCheckButton13:Disable();
			Semi_CoreOptionsCheckButton13:Hide();			
			Semi_CoreOptionsCheckButton_AB_BottomLeft:Disable();
			Semi_CoreOptionsCheckButton_AB_BottomLeft:Hide();
			Semi_CoreOptionsCheckButton_AB_BottomRight:Disable();
			Semi_CoreOptionsCheckButton_AB_BottomRight:Hide();
			Semi_CoreOptionsCheckButton23:ClearAllPoints();
			Semi_CoreOptionsCheckButton23:SetPoint("TOPLEFT", Semi_CoreOptions, "TOPLEFT", 30, -35);
	end		
	if (SF_Castbar_Ownership) then
		Semi_CoreOptionsCheckButton18:SetChecked(true);
		Semi_CoreOptionsCheckButton18Text:SetText(Semi_Core_String_CB18a);
		if (SF_Castbar_State) then
			Semi_CoreOptionsCheckButton4:SetChecked(true);
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
		else
			Semi_CoreOptionsCheckButton4:SetChecked(false);
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
		end
	else
		Semi_CoreOptionsCheckButton18:SetChecked(false);
		Semi_CoreOptionsCheckButton18Text:SetText(Semi_Core_String_CB18b);
		Semi_CoreOptionsCheckButton4:SetChecked(false);
		Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4c);
		Semi_CoreOptionsCheckButton4:Disable();
	end
	
	if (SF_AchievementFrame_Ownership) then
		Semi_CoreOptionsCheckButton19:SetChecked(true);
		Semi_CoreOptionsCheckButton19Text:SetText(Semi_Core_String_CB19a);
	else
		Semi_CoreOptionsCheckButton19:SetChecked(false);
		Semi_CoreOptionsCheckButton19Text:SetText(Semi_Core_String_CB19b);
	end
	
	if (SF_Vehicle_Art_State) then
		Semi_CoreOptionsCheckButton20:SetChecked(true);
		Semi_CoreOptionsCheckButton20Text:SetText(Semi_Core_String_CB20a);
	else
		Semi_CoreOptionsCheckButton20:SetChecked(false);
		Semi_CoreOptionsCheckButton20Text:SetText(Semi_Core_String_CB20b);
	end
	
	if (SF_Gryphon_State) then
		Semi_CoreOptionsCheckButton5:SetChecked(true);
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
	else
		Semi_CoreOptionsCheckButton5:SetChecked(false);
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
	end
	if (SF_XP_Bar_State) then
		Semi_CoreOptionsCheckButton17:SetChecked(true);
		Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17a);
	else
		Semi_CoreOptionsCheckButton17:SetChecked(false);
		Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17b);
	end
	if (IsAddOnLoaded("Semi_Extra_Bars")) then
		if (not IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_CoreOptionsCheckButton6:ClearAllPoints();
			Semi_CoreOptionsCheckButton6:SetPoint("TOPLEFT", Semi_CoreOptionsCheckButton19, "BOTTOMLEFT", 0, 0);
		end
		Semi_CoreOptionsCheckButton6:SetChecked(SF_EB_1_State);
		if (SF_EB_1_State) then 
			Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6a);
		else
			Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6b);
		end
		
		Semi_CoreOptionsCheckButton7:SetChecked(SF_EB_2_State);
		if (SF_EB_2_State) then
			Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7a);
		else
			Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7b);
		end
		
		Semi_CoreOptionsCheckButton8:SetChecked(SF_EB_3_State);
		if (SF_EB_3_State) then
			Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8a);
		else
			Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8b);
		end
		
		Semi_CoreOptionsCheckButton24:SetChecked(SF_EB_4_State);
		if (SF_EB_4_State) then
			Semi_CoreOptionsCheckButton24Text:SetText(Semi_Core_String_CB24a);
		else
			Semi_CoreOptionsCheckButton24Text:SetText(Semi_Core_String_CB24b);
		end
		
		Semi_CoreOptionsCheckButton9:SetChecked(Semi_EB_Grid);
		if (Semi_EB_Grid) then
			Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9a);
		else
			Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9b);
		end
		Semi_CoreOptionsCheckButton10:SetChecked(Semi_EB_Vehicle);
		if (Semi_EB_Vehicle) then
			Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10a);
		else
			Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10b);
		end
		Semi_CoreOptionsCheckButton14:SetChecked(SF_EB_Vert_1_State);
		if (SF_EB_Vert_1_State) then
			Semi_CoreOptionsCheckButton14Text:SetText(Semi_Core_String_CB14a);
		else
			Semi_CoreOptionsCheckButton14Text:SetText(Semi_Core_String_CB14b);
		end
		Semi_CoreOptionsCheckButton15:SetChecked(SF_EB_Vert_2_State);
		if (SF_EB_Vert_2_State) then
			Semi_CoreOptionsCheckButton15Text:SetText(Semi_Core_String_CB15a);
		else
			Semi_CoreOptionsCheckButton15Text:SetText(Semi_Core_String_CB15b);
		end
	else
		--horizontal bar 1 to 4
		Semi_CoreOptionsCheckButton6:Disable();
		Semi_CoreOptionsCheckButton6:Hide();
		Semi_CoreOptionsCheckButton7:Disable();
		Semi_CoreOptionsCheckButton7:Hide();
		Semi_CoreOptionsCheckButton8:Disable();
		Semi_CoreOptionsCheckButton8:Hide();
		Semi_CoreOptionsCheckButton24:Disable();
		Semi_CoreOptionsCheckButton24:Hide();
		--vert bar 1 to 2
		Semi_CoreOptionsCheckButton14:Disable();
		Semi_CoreOptionsCheckButton14:Hide();
		Semi_CoreOptionsCheckButton15:Disable();
		Semi_CoreOptionsCheckButton15:Hide();
		--grid box choice
		Semi_CoreOptionsCheckButton9:Disable();
		Semi_CoreOptionsCheckButton9:Hide();
		--vehicleui choice
		Semi_CoreOptionsCheckButton10:Disable();
		Semi_CoreOptionsCheckButton10:Hide();
	end
end

function Semi_CoreOptions_Mods_OnLoad(self)
	panel = Semi_CoreOptions_Mods;
	panel.name = "Modules";
	panel.parent = "Semi";
	
	InterfaceOptions_AddCategory(panel);
end

function Semi_CoreOptions_Mods_OnShow(self)
	self:SetBackdrop(BACKDROP_SEMI_16);
	BackdropTemplateMixin.OnBackdropLoaded(self);
	self:SetBackdropColor(0,0,0,1);

	if (not IsAddOnLoaded("Semi_ASR")) then 
 		_G[self:GetName().."CheckButton1"]:SetChecked(false);
		_G[self:GetName().."CheckButton1Text"]:SetText(Semi_Core_Mods_String_CB1b);
	else 
		Semi_CoreOptions_ModsCheckButton1:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	end

	if (not IsAddOnLoaded("Semi_Tip")) then
		Semi_CoreOptions_ModsCheckButton2:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2b);
	else
		Semi_CoreOptions_ModsCheckButton2:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	end

	if (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3b);
	else
		Semi_CoreOptions_ModsCheckButton3:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	end
	if (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4b);
	else
		Semi_CoreOptions_ModsCheckButton4:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	end
	if (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5b);
	else
		Semi_CoreOptions_ModsCheckButton5:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	end
	if (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6b);
	else
		Semi_CoreOptions_ModsCheckButton6:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	end
	
	if (not IsAddOnLoaded("Semi_Minimap_Mover")) then
		Semi_CoreOptions_ModsCheckButton7:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7b);
	else
		Semi_CoreOptions_ModsCheckButton7:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	end
		
	if (not IsAddOnLoaded("Semi_Hide_Buffs")) then
		Semi_CoreOptions_ModsCheckButton8:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8b);
	else
		Semi_CoreOptions_ModsCheckButton8:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	end
	
	if (not IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9b);
	else
		Semi_CoreOptions_ModsCheckButton9:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9a);
	end
	if (not IsAddOnLoaded("Semi_ClassColor_HealthBar")) then
		Semi_CoreOptions_ModsCheckButton10:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10b);
	else
		Semi_CoreOptions_ModsCheckButton10:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10a);
	end
	if (not IsAddOnLoaded("Semi_Extra_Scaling")) then
		Semi_CoreOptions_ModsCheckButton11:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton11Text:SetText(Semi_Core_Mods_String_CB11b);
	else
		Semi_CoreOptions_ModsCheckButton11:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton11Text:SetText(Semi_Core_Mods_String_CB11a);
	end
	if (not IsAddOnLoaded("Semi_Move_Objective_Frame")) then
		Semi_CoreOptions_ModsCheckButton12:SetChecked(false);
		Semi_CoreOptions_ModsCheckButton12Text:SetText(Semi_Core_Mods_String_CB12b);
	else
		Semi_CoreOptions_ModsCheckButton12:SetChecked(true);
		Semi_CoreOptions_ModsCheckButton12Text:SetText(Semi_Core_Mods_String_CB12a);
	end
end

function Semi_ScaleOptions_OnLoad(self)
	panel = Semi_ScaleOptions;
	panel.name = "Scaling";
	panel.parent = "Semi";
	
	InterfaceOptions_AddCategory(panel);
end

function Semi_ScaleOptions_OnShow(self)
	
	self:SetBackdrop(BACKDROP_SEMI_16);
	BackdropTemplateMixin.OnBackdropLoaded(self);
	self:SetBackdropColor(0,0,0,1);
	
	Semi_ScaleOptionsTitle:SetText(Semi_Scale_String_Title);
	
	Semi_PFSlider();
	Semi_PetFSlider();
	Semi_TFSlider();
	Semi_ToTFSlider();
	Semi_PartyScaleSlider();
	Semi_FocusFrameSlider();
	Semi_All_Bars_Slider();
	Semi_VehicleBar_Slider();
	Semi_PetBattleFrame_Slider();
	Semi_MinimapCluster_Slider();
	
	if IsAddOnLoaded("Semi_Action_Bars") then 
		Semi_MicroMenuButtons_Slider();
		if (CharacterMicroButton:GetParent():GetName()) ~= "MainMenuBarArtFrame" then
			SemiMicroMenuButtonsScaleSlider:Hide();
		end
	end
	if IsAddOnLoaded("Semi_Extra_Scaling") then
		Semi_FrameNames_Slider();
		Semi_CalendarFrame_Slider();
		Semi_WorldMapFrame_Slider();
	end

	if IsAddOnLoaded("Semi_Move_Objective_Frame") then
		Semi_ObjectiveFrame_Slider();
		Semi_Objective_Frame_Height_EditBox:SetPoint("TOP", SemiObjectiveFrameScaleSlider, "TOP", 0, -30);
		Semi_Objective_Frame_Height_EditBox:Show();
	end
	
	Semi_PetBar_Slider();
	Semi_BossTargetFrame_Slider();
	Semi_GroupLootFrame_Slider();

	if (Semiclass == "Death Knight") then
		Semi_RuneFrame_Slider();
	end
	
	if (IsAddOnLoaded("PlayerXPBar")) then
		Semi_Support_PlayerXPBar_Slider();
	end
end

function Semi_PFSlider()
	CreateFrame("Slider", "PlayerFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PlayerFrameScaleSlider:ClearAllPoints();
	PlayerFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -50);
	PlayerFrameScaleSlider:SetMinMaxValues(0.5, 2);
	PlayerFrameScaleSlider:SetValueStep(0.1);
	PlayerFrameScaleSlider:SetValue(Semi_Player_Scale);
	PlayerFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_Player_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[PlayerFrameScaleSlider:GetName().."Text"]:SetText("Player Frame:   "..Semi_Player_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[PlayerFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[PlayerFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PlayerFrameScaleSlider:GetName().."Text"]:SetText("Player Frame:   "..Semi_Player_Scale);
	PlayerFrameScaleSlider:Show();
end

function Semi_RuneFrame_Slider()
	CreateFrame("Slider", "RuneFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	RuneFrameScaleSlider:ClearAllPoints();
	RuneFrameScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -150);
	RuneFrameScaleSlider:SetMinMaxValues(0.5, 2);
	RuneFrameScaleSlider:SetValueStep(0.1);
	RuneFrameScaleSlider:SetValue(Semi_RuneFrame_Scale);
	RuneFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_RuneFrame_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[RuneFrameScaleSlider:GetName().."Text"]:SetText("Rune Frame:   "..Semi_RuneFrame_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[RuneFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[RuneFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[RuneFrameScaleSlider:GetName().."Text"]:SetText("Rune Frame:   "..Semi_RuneFrame_Scale);
	RuneFrameScaleSlider:Show();

end

function Semi_PetFSlider()
	CreateFrame("Slider", "PetFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PetFrameScaleSlider:ClearAllPoints();
	PetFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -100);
	PetFrameScaleSlider:SetMinMaxValues(0.5, 2);
	PetFrameScaleSlider:SetValueStep(0.1);
	PetFrameScaleSlider:SetValue(Semi_Pet_Scale);
	PetFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_Pet_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[PetFrameScaleSlider:GetName().."Text"]:SetText("Pet Frame:   "..Semi_Pet_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[PetFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[PetFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PetFrameScaleSlider:GetName().."Text"]:SetText("Pet Frame:   "..Semi_Pet_Scale);
	PetFrameScaleSlider:Show();
end

function Semi_TFSlider()
	CreateFrame("Slider", "TargetFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	TargetFrameScaleSlider:ClearAllPoints();
	TargetFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -150);
	TargetFrameScaleSlider:SetMinMaxValues(0.5, 2);
	TargetFrameScaleSlider:SetValueStep(0.1);
	TargetFrameScaleSlider:SetValue(Semi_Target_Scale);
	TargetFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_Target_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[TargetFrameScaleSlider:GetName().."Text"]:SetText("Target Frame:   "..Semi_Target_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[TargetFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[TargetFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[TargetFrameScaleSlider:GetName().."Text"]:SetText("Target Frame:   "..Semi_Target_Scale);
	TargetFrameScaleSlider:Show();
end

function Semi_ToTFSlider()
	CreateFrame("Slider", "TargetofTargetFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	TargetofTargetFrameScaleSlider:ClearAllPoints();
	TargetofTargetFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -200);
	TargetofTargetFrameScaleSlider:SetMinMaxValues(0.25, 3);
	TargetofTargetFrameScaleSlider:SetValueStep(0.05);
	TargetofTargetFrameScaleSlider:SetValue(Semi_ToT_Scale);
	TargetofTargetFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
			new_value = semi_round(value, 2);
			self:SetValue(new_value);
			Semi_ToT_Scale_On_Change(new_value);
			GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
			GameTooltip:SetText(new_value);
			_G[TargetofTargetFrameScaleSlider:GetName().."Text"]:SetText("Target of Target:   "..Semi_ToT_Scale);
			GameTooltip:Show();
			GameTooltip:FadeOut();
			end)
	_G[TargetofTargetFrameScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[TargetofTargetFrameScaleSlider:GetName().."High"]:SetText("3");
	_G[TargetofTargetFrameScaleSlider:GetName().."Text"]:SetText("Target of Target:   "..Semi_ToT_Scale);
	TargetofTargetFrameScaleSlider:Show();
end

function Semi_PartyScaleSlider()
	CreateFrame("Slider", "PartyFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PartyFrameScaleSlider:ClearAllPoints();
	PartyFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -250);
	PartyFrameScaleSlider:SetMinMaxValues(0.5, 2);
	PartyFrameScaleSlider:SetValueStep(0.1);
	PartyFrameScaleSlider:SetValue(Semi_PartyFrame_Scale);
	PartyFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_PartyFrame_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[PartyFrameScaleSlider:GetName().."Text"]:SetText("Party Frames:  "..Semi_PartyFrame_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[PartyFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[PartyFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PartyFrameScaleSlider:GetName().."Text"]:SetText("Party Frames:  "..Semi_PartyFrame_Scale);
	PartyFrameScaleSlider:Show();
end

function Semi_FocusFrameSlider()
	CreateFrame("Slider", "FocusFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	FocusFrameScaleSlider:ClearAllPoints();
	FocusFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -300);
	FocusFrameScaleSlider:SetMinMaxValues(0.5, 2);
	FocusFrameScaleSlider:SetValueStep(0.1);
	FocusFrameScaleSlider:SetValue(Semi_FocusFrame_Scale);
	FocusFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 1);
						self:SetValue(new_value);
						Semi_FocusFrame_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[FocusFrameScaleSlider:GetName().."Text"]:SetText("Focus Frame:  "..Semi_FocusFrame_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[FocusFrameScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[FocusFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[FocusFrameScaleSlider:GetName().."Text"]:SetText("Focus Frame:  "..Semi_FocusFrame_Scale);
	FocusFrameScaleSlider:Show();
	
end

function Semi_BossTargetFrame_Slider()
	CreateFrame("Slider", "BossTargetFramesScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	BossTargetFramesScaleSlider:ClearAllPoints();
	BossTargetFramesScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -400);
	BossTargetFramesScaleSlider:SetMinMaxValues(0.25, 2);
	BossTargetFramesScaleSlider:SetValueStep(0.05);
	BossTargetFramesScaleSlider:SetValue(Semi_BossTargetFrame_Scale);
	BossTargetFramesScaleSlider:SetScript("OnValueChanged", function (self, value)
							new_value = semi_round(value, 2);
							self:SetValue(new_value);
							Semi_BossTargetFrames_Scale_On_Change(new_value);
							GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
							GameTooltip:SetText(new_value);
							_G[BossTargetFramesScaleSlider:GetName().."Text"]:SetText("Boss Frames: "..Semi_BossTargetFrame_Scale);
							GameTooltip:Show();
							GameTooltip:FadeOut();
						end)
	_G[BossTargetFramesScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[BossTargetFramesScaleSlider:GetName().."High"]:SetText("2");
	_G[BossTargetFramesScaleSlider:GetName().."Text"]:SetText("Boss Frames: "..Semi_BossTargetFrame_Scale);
	BossTargetFramesScaleSlider:Show();
end

function Semi_GroupLootFrame_Slider()
	CreateFrame("Slider", "GroupLootFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	GroupLootFrameScaleSlider:ClearAllPoints();
	GroupLootFrameScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -350);
	GroupLootFrameScaleSlider:SetMinMaxValues(0.25, 2);
	GroupLootFrameScaleSlider:SetValueStep(0.05);
	GroupLootFrameScaleSlider:SetValue(Semi_GroupLootFrame_Scale);
	GroupLootFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
							new_value = semi_round(value, 2);
							self:SetValue(new_value);
							Semi_GroupLootFrame_Scale_On_Change(new_value);
							GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
							GameTooltip:SetText(new_value);
							_G[GroupLootFrameScaleSlider:GetName().."Text"]:SetText("GroupLoot Frame: "..Semi_GroupLootFrame_Scale);
							GameTooltip:Show();
							GameTooltip:FadeOut();
						end)
	_G[GroupLootFrameScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[GroupLootFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[GroupLootFrameScaleSlider:GetName().."Text"]:SetText("GroupLoot Frame: "..Semi_GroupLootFrame_Scale);
	GroupLootFrameScaleSlider:Show();
end

function Semi_All_Bars_Slider()
	CreateFrame("Slider", "AllActionBarsScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	AllActionBarsScaleSlider:ClearAllPoints();
	AllActionBarsScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -50);
	AllActionBarsScaleSlider:SetMinMaxValues(0.25, 2.5);
	AllActionBarsScaleSlider:SetValueStep(0.05);
	AllActionBarsScaleSlider:SetValue(Semi_AllBars_Scale);
	AllActionBarsScaleSlider:SetScript("OnValueChanged", function (self, value)
								new_value = semi_round(value, 2);
								self:SetValue(new_value);
								Semi_All_Bars_Scale_On_Change(new_value);
								GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
								GameTooltip:SetText(new_value);
								_G[AllActionBarsScaleSlider:GetName().."Text"]:SetText("All Action Bars:   "..Semi_AllBars_Scale);
								GameTooltip:Show();
								GameTooltip:FadeOut();
							end)
	_G[AllActionBarsScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[AllActionBarsScaleSlider:GetName().."High"]:SetText("2.5");
	_G[AllActionBarsScaleSlider:GetName().."Text"]:SetText("All Action Bars:   "..Semi_AllBars_Scale);
	AllActionBarsScaleSlider:Show();
end

function Semi_MicroMenuButtons_Slider()
	CreateFrame("Slider", "SemiMicroMenuButtonsScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiMicroMenuButtonsScaleSlider:ClearAllPoints();
	SemiMicroMenuButtonsScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -150);
	SemiMicroMenuButtonsScaleSlider:SetMinMaxValues(0.25, 2.5);
	SemiMicroMenuButtonsScaleSlider:SetValueStep(0.05);
	SemiMicroMenuButtonsScaleSlider:SetValue(Semi_MicroMenuButtons_Scale);
	SemiMicroMenuButtonsScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_MicroMenuButtons_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[SemiMicroMenuButtonsScaleSlider:GetName().."Text"]:SetText("Micro Buttons:  "..Semi_MicroMenuButtons_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiMicroMenuButtonsScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[SemiMicroMenuButtonsScaleSlider:GetName().."High"]:SetText("2.5");
	_G[SemiMicroMenuButtonsScaleSlider:GetName().."Text"]:SetText("Micro Buttons:  "..Semi_MicroMenuButtons_Scale);
	SemiMicroMenuButtonsScaleSlider:Show();
end

function Semi_VehicleBar_Slider()
	CreateFrame("Slider", "VehicleBarScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	VehicleBarScaleSlider:ClearAllPoints();
	VehicleBarScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -50);
	VehicleBarScaleSlider:SetMinMaxValues(0.15, 2);
	VehicleBarScaleSlider:SetValueStep(0.05);
	VehicleBarScaleSlider:SetValue(Semi_VehicleBar_Scale);
	VehicleBarScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_VehicleBar_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[VehicleBarScaleSlider:GetName().."Text"]:SetText("Vehicle Bar:  "..Semi_VehicleBar_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[VehicleBarScaleSlider:GetName().."Low"]:SetText("0.15");
	_G[VehicleBarScaleSlider:GetName().."High"]:SetText("2");
	_G[VehicleBarScaleSlider:GetName().."Text"]:SetText("Vehicle Bar:  "..Semi_VehicleBar_Scale);
	VehicleBarScaleSlider:Show();
end

function Semi_PetBattleFrame_Slider()
	CreateFrame("Slider", "PetBattleFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PetBattleFrameScaleSlider:ClearAllPoints();
	PetBattleFrameScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -100);
	PetBattleFrameScaleSlider:SetMinMaxValues(0.15, 2);
	PetBattleFrameScaleSlider:SetValueStep(0.05);
	PetBattleFrameScaleSlider:SetValue(Semi_PetBattleFrame_Scale);
	PetBattleFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_PetBattleFrame_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[PetBattleFrameScaleSlider:GetName().."Text"]:SetText("Pet Battle:  "..Semi_PetBattleFrame_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[PetBattleFrameScaleSlider:GetName().."Low"]:SetText("0.15");
	_G[PetBattleFrameScaleSlider:GetName().."High"]:SetText("2");
	_G[PetBattleFrameScaleSlider:GetName().."Text"]:SetText("Pet Battle :  "..Semi_PetBattleFrame_Scale);
	PetBattleFrameScaleSlider:Show();
end

function Semi_MinimapCluster_Slider()
	CreateFrame("Slider", "MinimapClusterScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	MinimapClusterScaleSlider:ClearAllPoints();
	MinimapClusterScaleSlider:SetPoint("TOPLEFT", Semi_ScaleOptions, "TOPLEFT", 30, -450);
	MinimapClusterScaleSlider:SetMinMaxValues(0.5, 2);
	MinimapClusterScaleSlider:SetValueStep(0.05);
	MinimapClusterScaleSlider:SetValue(Semi_MinimapCluster_Scale);
	MinimapClusterScaleSlider:SetScript("OnValueChanged", function (self, value)
						new_value = semi_round(value, 2);
						self:SetValue(new_value);
						Semi_MinimapCluster_Scale_On_Change(new_value);
						GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
						GameTooltip:SetText(new_value);
						_G[MinimapClusterScaleSlider:GetName().."Text"]:SetText("Minimap:   "..Semi_MinimapCluster_Scale);
						GameTooltip:Show();
						GameTooltip:FadeOut();
					end)
	_G[MinimapClusterScaleSlider:GetName().."Low"]:SetText("0.5");
	_G[MinimapClusterScaleSlider:GetName().."High"]:SetText("2");
	_G[MinimapClusterScaleSlider:GetName().."Text"]:SetText("Minimap:   "..Semi_MinimapCluster_Scale);
	MinimapClusterScaleSlider:Show();
end

function Semi_PetBar_Slider()
	CreateFrame("Slider", "PetBarScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	PetBarScaleSlider:ClearAllPoints();
	PetBarScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -100);
	PetBarScaleSlider:SetMinMaxValues(0.25, 2);
	PetBarScaleSlider:SetValueStep(0.05);
	PetBarScaleSlider:SetValue(Semi_PetBar_Scale);
	PetBarScaleSlider:SetScript("OnValueChanged", function (self, value)
		new_value = semi_round(value, 2);
		self:SetValue(new_value);
		Semi_PetBar_Scale_On_Change(new_value);
		GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
		GameTooltip:SetText(new_value);
		_G[PetBarScaleSlider:GetName().."Text"]:SetText("Pet Bar:   "..Semi_PetBar_Scale);
		GameTooltip:Show();
		GameTooltip:FadeOut();
		end)
	_G[PetBarScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[PetBarScaleSlider:GetName().."High"]:SetText("2");
	_G[PetBarScaleSlider:GetName().."Text"]:SetText("Pet Bar:   "..Semi_PetBar_Scale);
	PetBarScaleSlider:Show();
end

--[[
function Semi_TotemBar_Slider()
	CreateFrame("Slider", "TotemBarScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	TotemBarScaleSlider:ClearAllPoints();
	TotemBarScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -150);
	TotemBarScaleSlider:SetMinMaxValues(0.25, 2);
	TotemBarScaleSlider:SetValueStep(0.05);
	TotemBarScaleSlider:SetValue(Semi_TotemBar_Scale);
	TotemBarScaleSlider:SetScript("OnValueChanged", function (self, value)
							new_value = semi_round(value, 2);
							self:SetValue(new_value);
							Semi_TotemBar_Scale_On_Change(new_value);
							GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
							GameTooltip:SetText(new_value);
							_G[TotemBarScaleSlider:GetName().."Text"]:SetText("Totem Bar:   "..Semi_TotemBar_Scale);
							GameTooltip:Show();
							GameTooltip:FadeOut();
						end)
	_G[TotemBarScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[TotemBarScaleSlider:GetName().."High"]:SetText("2");
	_G[TotemBarScaleSlider:GetName().."Text"]:SetText("Totem Bar:   "..Semi_TotemBar_Scale);
	TotemBarScaleSlider:Show();
end

function Semi_AspectBar_Slider()
	CreateFrame("Slider", "AspectBarScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	AspectBarScaleSlider:ClearAllPoints();
	AspectBarScaleSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -150);
	AspectBarScaleSlider:SetMinMaxValues(0.25, 2);
	AspectBarScaleSlider:SetValueStep(0.05);
	AspectBarScaleSlider:SetValue(Semi_AspectBar_Scale);
	AspectBarScaleSlider:SetScript("OnValueChanged", function (self, value)
							new_value = semi_round(value, 2);
							self:SetValue(new_value);
							Semi_AspectBar_Scale_On_Change(new_value);
							GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
							GameTooltip:SetText(new_value);
							_G[AspectBarScaleSlider:GetName().."Text"]:SetText("Aspect Bar:   "..Semi_AspectBar_Scale);
							GameTooltip:Show();
							GameTooltip:FadeOut();
						end)
	_G[AspectBarScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[AspectBarScaleSlider:GetName().."High"]:SetText("2");
	_G[AspectBarScaleSlider:GetName().."Text"]:SetText("Aspect Bar:   "..Semi_AspectBar_Scale);
	AspectBarScaleSlider:Show();
end
--]]
function Semi_Support_PlayerXPBar_Slider()
	CreateFrame("Slider", "SemiSupportPlayerXPBarSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiSupportPlayerXPBarSlider:ClearAllPoints();
	if Semiclass == "Death Knight" then
		SemiSupportPlayerXPBarSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -200);
	else
		SemiSupportPlayerXPBarSlider:SetPoint("TOPRIGHT", Semi_ScaleOptions, "TOPRIGHT", -30, -150);
	end
	SemiSupportPlayerXPBarSlider:SetMinMaxValues(0.5, 2);
	SemiSupportPlayerXPBarSlider:SetValueStep(0.1);
	SemiSupportPlayerXPBarSlider:SetValue(Semi_Support_PlayerXPBar_Scale);
	SemiSupportPlayerXPBarSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 1);
									self:SetValue(new_value);
									Semi_Support_PlayerXPBar_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[SemiSupportPlayerXPBarSlider:GetName().."Text"]:SetText("PlayerXPBar: "..Semi_Support_PlayerXPBar_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiSupportPlayerXPBarSlider:GetName().."Low"]:SetText("0.5");
	_G[SemiSupportPlayerXPBarSlider:GetName().."High"]:SetText("2");
	_G[SemiSupportPlayerXPBarSlider:GetName().."Text"]:SetText("PlayerXPBar: "..Semi_Support_PlayerXPBar_Scale);
	SemiSupportPlayerXPBarSlider:Show();
end

function Semi_Player_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Player_Scale = PassedValueFromSliderOrEvent;
	PlayerFrame:SetScale(Semi_Player_Scale);
	if (Semiclass == "Death Knight") then
			RuneFrame:SetScale(Semi_RuneFrame_Scale);
			RuneFrame:SetPoint("BOTTOM", "PlayerFrame", "BOTTOM", 0, -10);
	end
end	

function Semi_RuneFrame_Scale_On_Change(PassedValueFromSlider)
	Semi_RuneFrame_Scale = PassedValueFromSlider;
	RuneFrame:SetScale(Semi_RuneFrame_Scale);
	RuneFrame:SetPoint("BOTTOM", "PlayerFrame", "BOTTOM", 0, -10);
end

function Semi_Pet_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Pet_Scale = PassedValueFromSliderOrEvent;
	PetFrame:SetScale(Semi_Pet_Scale);
end

function Semi_Target_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Target_Scale = PassedValueFromSliderOrEvent;
	TargetFrame:SetScale(Semi_Target_Scale);
end

function Semi_ToT_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_ToT_Scale = PassedValueFromSliderOrEvent;
	TargetFrameToT:SetScale(Semi_ToT_Scale);
end

function Semi_PartyFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_PartyFrame_Scale = PassedValueFromSliderOrEvent;
	PartyMemberFrame1:SetScale(Semi_PartyFrame_Scale);
	PartyMemberFrame2:SetScale(Semi_PartyFrame_Scale);
	PartyMemberFrame3:SetScale(Semi_PartyFrame_Scale);
	PartyMemberFrame4:SetScale(Semi_PartyFrame_Scale);
end

function Semi_FocusFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_FocusFrame_Scale = PassedValueFromSliderOrEvent;
	FocusFrame:SetScale(Semi_FocusFrame_Scale);
end

function Semi_BossTargetFrames_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_BossTargetFrame_Scale = PassedValueFromSliderOrEvent;
	if (not InCombatLockdown()) then
		Boss1TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
		Boss2TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
		Boss3TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
		Boss4TargetFrame:SetScale(Semi_BossTargetFrame_Scale);
	end
end

function Semi_GroupLootFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_GroupLootFrame_Scale = PassedValueFromSliderOrEvent;
	GroupLootFrame1:SetScale(Semi_GroupLootFrame_Scale);
	GroupLootFrame2:SetScale(Semi_GroupLootFrame_Scale);
	GroupLootFrame3:SetScale(Semi_GroupLootFrame_Scale);
	GroupLootFrame4:SetScale(Semi_GroupLootFrame_Scale);
end

function Semi_All_Bars_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_AllBars_Scale = PassedValueFromSliderOrEvent;
	--if (IsAddOnLoaded("Semi_Extra_Bars")) then
	if _G["Semi_EB_Bar1"] then
		SetExtraBarScale(Semi_AllBars_Scale);
	end
	--if (IsAddOnLoaded("Semi_Action_Bars")) then
	if _G["Semi_MainMenu_Bar"] then
		SetMenuBarScale(Semi_AllBars_Scale);
	elseif _G["MainMenuBar"] then
		_G["MainMenuBar"]:SetScale(Semi_AllBars_Scale);
	end
end

function Semi_MicroMenuButtons_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_MicroMenuButtons_Scale = PassedValueFromSliderOrEvent;
		for i=1,12 do
			SemiMicroMenuButtons[i]:SetScale(Semi_MicroMenuButtons_Scale);
		end
end


function Semi_VehicleBar_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_VehicleBar_Scale = PassedValueFromSliderOrEvent;
	OverrideActionBar:SetScale(Semi_VehicleBar_Scale);
end

function Semi_PetBattleFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_PetBattleFrame_Scale = PassedValueFromSliderOrEvent;
	PetBattleFrame:SetScale(Semi_PetBattleFrame_Scale);
end

function Semi_MinimapCluster_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_MinimapCluster_Scale = PassedValueFromSliderOrEvent;
	if (IsAddOnLoaded("Semi_Minimap_Mover")) then
		MinimapCluster:SetScale(Semi_MinimapCluster_Scale);
		SemiMinimapClusterDragButton:SetScale(Semi_MinimapCluster_Scale);
	else
		MinimapCluster:ClearAllPoints();
		MinimapCluster:SetScale(Semi_MinimapCluster_Scale);
		MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT",  0, 0);
	end
end

function Semi_PetBar_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_PetBar_Scale = PassedValueFromSliderOrEvent;
	if (IsAddOnLoaded("Semi_Action_Bars")) then
		SetPetBarScale(Semi_PetBar_Scale);
	else
		PetActionBarFrame:SetScale(Semi_PetBar_Scale);
	end
end

function Semi_Support_PlayerXPBar_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_Support_PlayerXPBar_Scale = PassedValueFromSliderOrEvent;
	PlayerXPBar:SetScale(Semi_Support_PlayerXPBar_Scale);
end

function semi_round(tempnumber, decimals)
	return (("%%.%df"):format(decimals)):format(tempnumber)
end

function Semi_Bags_Options()
	SF_Bags_State = Semi_CoreOptionsCheckButton1:GetChecked() or false;
	if (SF_Bags_State) then
		ShowSemiBags();
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1a);
		Semi_LinkInventoryBagsToDragButton();
	end
	if (not SF_Bags_State) then
		HideSemiBags();
		Semi_CoreOptionsCheckButton1Text:SetText(Semi_Core_String_CB1b);
	end
end

function Semi_BagReset_Options(self)
	Semi_BagReset_State = self:GetChecked() or false;
	if Semi_BagReset_State then
		Semi_CoreOptionsCheckButton23Text:SetText(Semi_Core_String_CB23a)
	else
		Semi_CoreOptionsCheckButton23Text:SetText(Semi_Core_String_CB23b)
	end
end

function Semi_MapFarm_Options(self)
	Semi_MapFarm = self:GetChecked() or false;
	if Semi_MapFarm then
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3a)
	else
		Semi_CoreOptionsCheckButton3Text:SetText(Semi_Core_String_CB3b)
	end
	Semi_MapFarm_Driver()
end

function Semi_MicroMenu_Options()
	SF_MicroMenu_State = Semi_CoreOptionsCheckButton2:GetChecked() or false;
	if (SF_MicroMenu_State) then
		ShowSemiMenu();
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2a);
		Semi_LinkMicroMenuToDragButton();
	end
	if (not SF_MicroMenu_State) then
		HideSemiMenu();
		Semi_CoreOptionsCheckButton2Text:SetText(Semi_Core_String_CB2b);
	end
end

function Semi_AB_Vehicle_Options()
	Semi_AB_Vehicle = Semi_CoreOptionsCheckButton12:GetChecked() or false;
	if (Semi_AB_Vehicle) then
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12a);
	else
		Semi_CoreOptionsCheckButton12Text:SetText(Semi_Core_String_CB12b);
	end
	--call all 3 bars to update
	Semi_Bar_StateDriver("Semi_MainMenu_Bar", Semi_AB_Main_State, Semi_AB_Vehicle);
	Semi_Bar_StateDriver("Semi_BottomLeft_Bar", Semi_AB_BL_State, Semi_AB_Vehicle);
	Semi_Bar_StateDriver("Semi_BottomRight_Bar", Semi_AB_BR_State, Semi_AB_Vehicle);
	
end

function Semi_AB_MainMenu_Options()
	Semi_AB_Main_State = Semi_CoreOptionsCheckButton13:GetChecked() or false;
	if (Semi_AB_Main_State) then
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13a);
		Semi_CoreOptionsCheckButton_AB_BottomLeft:Enable();
		Semi_CoreOptionsCheckButton_AB_BottomRight:Enable();
	else
		Semi_CoreOptionsCheckButton13Text:SetText(Semi_Core_String_CB13b);
		
		Semi_CoreOptionsCheckButton_AB_BottomLeft:SetChecked(false);
		Semi_AB_BottomLeft_Options();
		Semi_CoreOptionsCheckButton_AB_BottomLeft:Disable();
		Semi_CoreOptionsCheckButton_AB_BottomRight:SetChecked(false);
		Semi_AB_BottomRight_Options();
		Semi_CoreOptionsCheckButton_AB_BottomRight:Disable();
	end
	Semi_Bar_StateDriver("Semi_MainMenu_Bar", Semi_AB_Main_State, Semi_AB_Vehicle);
	Semi_Blizzard_MainMenu(not Semi_AB_Main_State);
end

function Semi_Blizzard_MainMenu(useme)
	if useme then
		MainMenuBar:SetUserPlaced(false);
	else
		MainMenuBar:ClearAllPoints();
		MainMenuBar:SetPoint("TOP", UIParent, "BOTTOM", 0, -250);
		MainMenuBar:SetMovable(true);
		MainMenuBar:SetUserPlaced(true);
		
	end
end

function Semi_AB_BottomLeft_Options()
	Semi_AB_BL_State = Semi_CoreOptionsCheckButton_AB_BottomLeft:GetChecked() or false;
	if (Semi_AB_BL_State) then
		Semi_CoreOptionsCheckButton_AB_BottomLeftText:SetText(Semi_Core_String_CB21a);
	else
		Semi_CoreOptionsCheckButton_AB_BottomLeftText:SetText(Semi_Core_String_CB21b);
	end
	Semi_Bar_StateDriver("Semi_BottomLeft_Bar", Semi_AB_BL_State, Semi_AB_Vehicle);
end

function Semi_AB_BottomRight_Options()
	Semi_AB_BR_State = Semi_CoreOptionsCheckButton_AB_BottomRight:GetChecked() or false;
	if (Semi_AB_BR_State) then
		Semi_CoreOptionsCheckButton_AB_BottomRightText:SetText(Semi_Core_String_CB22a);
	else
		Semi_CoreOptionsCheckButton_AB_BottomRightText:SetText(Semi_Core_String_CB22b);
	end
	Semi_Bar_StateDriver("Semi_BottomRight_Bar", Semi_AB_BR_State, Semi_AB_Vehicle);
end

function Semi_MainMenuBarGridChoice_Options()
	SF_MainMenuBarGrid_State = Semi_CoreOptionsCheckButton16:GetChecked() or false;
	if (SF_MainMenuBarGrid_State) then
		Semi_CoreOptionsCheckButton16Text:SetText(Semi_Core_String_CB16a);
	end
	if (not SF_MainMenuBarGrid_State) then
		Semi_CoreOptionsCheckButton16Text:SetText(Semi_Core_String_CB16b);
	end
	Semi_MainMenuBarGridChoice();
end


function Semi_ExtraBar1_Options()
	SF_EB_1_State = Semi_CoreOptionsCheckButton6:GetChecked() or false;
	if (SF_EB_1_State) then
		Semi_Bar_StateDriver("Semi_EB_Bar1", true, Semi_EB_Vehicle);
		Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6a);
		
		Semi_CoreOptionsCheckButton14:SetChecked(false);
		Semi_Vert_Bar1_Options();
	end
	if (not SF_EB_1_State) then

		Semi_Bar_StateDriver("Semi_EB_Bar1", false, Semi_EB_Vehicle);

		Semi_CoreOptionsCheckButton6Text:SetText(Semi_Core_String_CB6b);

	end
end

function Semi_ExtraBar2_Options()
	SF_EB_2_State = Semi_CoreOptionsCheckButton7:GetChecked() or false;
	if (SF_EB_2_State) then
		--Semi_Bar_ShowHide("Semi_EB_Bar2", true);
		Semi_Bar_StateDriver("Semi_EB_Bar2", true, Semi_EB_Vehicle);
		Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7a);
		
		Semi_CoreOptionsCheckButton15:SetChecked(false);
		Semi_Vert_Bar2_Options();
	end
	if (not SF_EB_2_State) then
		Semi_Bar_StateDriver("Semi_EB_Bar2", false, Semi_EB_Vehicle);
		--Semi_Bar_ShowHide("Semi_EB_Bar2", false);
		Semi_CoreOptionsCheckButton7Text:SetText(Semi_Core_String_CB7b);
		
	end
end

function Semi_ExtraBar3_Options()
	SF_EB_3_State = Semi_CoreOptionsCheckButton8:GetChecked() or false;
	if (SF_EB_3_State) then
		--Semi_Bar_ShowHide("Semi_EB_Bar3", true);
		Semi_Bar_StateDriver("Semi_EB_Bar3", true, Semi_EB_Vehicle);
		Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8a);
		
	end
	if (not SF_EB_3_State) then
		Semi_Bar_StateDriver("Semi_EB_Bar3", false, Semi_EB_Vehicle);
		--Semi_Bar_ShowHide("Semi_EB_Bar3", false);
		Semi_CoreOptionsCheckButton8Text:SetText(Semi_Core_String_CB8b);
		
	end
end

function Semi_ExtraBar4_Options()
	SF_EB_4_State = Semi_CoreOptionsCheckButton24:GetChecked() or false;
	if (SF_EB_4_State) then
		--Semi_Bar_ShowHide("Semi_EB_Bar4", true);
		Semi_Bar_StateDriver("Semi_EB_Bar4", true, Semi_EB_Vehicle);
		Semi_CoreOptionsCheckButton24Text:SetText(Semi_Core_String_CB24a);
		
	end
	if (not SF_EB_4_State) then
		Semi_Bar_StateDriver("Semi_EB_Bar4", false, Semi_EB_Vehicle);
		--Semi_Bar_ShowHide("Semi_EB_Bar4", false);
		Semi_CoreOptionsCheckButton24Text:SetText(Semi_Core_String_CB24b);
		
	end
end

function Semi_Vert_Bar1_Options()
	SF_EB_Vert_1_State = Semi_CoreOptionsCheckButton14:GetChecked() or false;
	if (SF_EB_Vert_1_State) then
		--Semi_Bar_ShowHide("Semi_EB_Vert_Bar1", true);
		Semi_Bar_StateDriver("Semi_EB_Vert_Bar1", true, Semi_EB_Vehicle);
		Semi_CoreOptionsCheckButton14Text:SetText(Semi_Core_String_CB14a);
		
		
		Semi_CoreOptionsCheckButton6:SetChecked(false);
		Semi_ExtraBar1_Options();
	end
	if (not SF_EB_Vert_1_State) then
		Semi_Bar_StateDriver("Semi_EB_Vert_Bar1", false, Semi_EB_Vehicle);
		--Semi_Bar_ShowHide("Semi_EB_Vert_Bar1", false);
		Semi_CoreOptionsCheckButton14Text:SetText(Semi_Core_String_CB14b);
		
	end
end

function Semi_Vert_Bar2_Options()
	SF_EB_Vert_2_State = Semi_CoreOptionsCheckButton15:GetChecked() or false;
	if (SF_EB_Vert_2_State) then
		--Semi_Bar_ShowHide("Semi_EB_Vert_Bar2", true);
		Semi_Bar_StateDriver("Semi_EB_Vert_Bar2", true, Semi_EB_Vehicle);
		Semi_CoreOptionsCheckButton15Text:SetText(Semi_Core_String_CB15a);
		
		
		Semi_CoreOptionsCheckButton7:SetChecked(false);
		Semi_ExtraBar2_Options();
	end
	if (not SF_EB_Vert_2_State) then
		Semi_Bar_StateDriver("Semi_EB_Vert_Bar2", false, Semi_EB_Vehicle);
		--Semi_Bar_ShowHide("Semi_EB_Vert_Bar2", false);
		Semi_CoreOptionsCheckButton15Text:SetText(Semi_Core_String_CB15b);
	end
end



function Semi_Grid_Choice_Options()
	SF_Grid_State = Semi_CoreOptionsCheckButton9:GetChecked() or false;
	
	if (SF_Grid_State) then
		Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9a);
	end
	if (not SF_Grid_State) then
		Semi_CoreOptionsCheckButton9Text:SetText(Semi_Core_String_CB9b);
	end
	Semi_GridChoice();
end

function Semi_Extra_Bars_Vehicle_Alpha_Choice()
	Semi_EB_Vehicle = Semi_CoreOptionsCheckButton10:GetChecked() or false;
	if (Semi_EB_Vehicle) then
		Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10a);
	end
	if (not Semi_EB_Vehicle) then
		Semi_CoreOptionsCheckButton10Text:SetText(Semi_Core_String_CB10b);
	end
	--when this changes... all the bars with statedrivers need to update
	--easiest way is to call each option and it does it itself
	Semi_ExtraBar1_Options();
	Semi_ExtraBar2_Options();
	Semi_ExtraBar3_Options();
	Semi_ExtraBar4_Options();
	Semi_Vert_Bar1_Options();
	Semi_Vert_Bar2_Options();
end

function Semi_Frames_Unlock(location)
	if (not InCombatLockdown()) then
		if location == true then
			InterfaceOptionsFrame:Hide();
		end
		Semi_LockDownButtonFrame:Show();
		SemiVehicleLeaveDragButton:Show();

		if (not CanExitVehicle()) then
			MainMenuBarVehicleLeaveButton:Show();
		end
		SemiPlayerPowerBarAltDragButton:Show();
		SemiExtraActionButtonDragButton:Show();
		SemiExtraAbilityContainerDragButton:Show();
		if (SF_Castbar_State) then
			SemiCastingBarDragButton:Show();
		end
		if (SF_AchievementFrame_Ownership) then
			SemiAchievementFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SFTOTTargetofTargetFrameDragButton:Show();
		end
		if (IsAddOnLoaded("Semi_Hide_Buffs")) then
			SemiBuffFrameDragButton:SetAlpha(1);
		end
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			if Semi_AB_Main_State then
				Semi_MainMenu_BarActionBarDragButton:Show();
			end
			SemiOverrideActionBarDragButton:Show();
			if Semi_AB_BL_State then
				Semi_BottomLeft_BarActionBarDragButton:Show();
			end
			if Semi_AB_BR_State then
				Semi_BottomRight_BarActionBarDragButton:Show();
			end
			if SF_Bags_State then
				SemiInventoryBagsDragButton:Show();
			end
			if SF_MicroMenu_State then
				SemiMicroMenuDragButton:Show();
			end
			SemiPossessBarFrameDragButton:Show();
			
			if SemiPetBar:IsShown() then
				SemiPetBarDragButton:Show();
			end
			if StanceButton1:IsShown() then
				SemiStanceBarDragButton:Show();
			end
			
		end	
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			local SEB = {
				"SF_EB_1_State",
				"SF_EB_2_State",
				"SF_EB_3_State",
				"SF_EB_4_State",
				"SF_EB_Vert_1_State",
				"SF_EB_Vert_2_State"
			};
			local SEBdrag = {
				"Semi_EB_Bar1",
				"Semi_EB_Bar2",
				"Semi_EB_Bar3",
				"Semi_EB_Bar4",
				"Semi_EB_Vert_Bar1",
				"Semi_EB_Vert_Bar2"
			};
			for i=1,6 do
				if _G[SEB[i]] then
					_G[SEBdrag[i].."ActionBarDragButton"]:Show();
					
				end
			end
		end

		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			SemiGroupLootFrameDragButton:Show();
		end
	else
		print("You can't unlock the frames during combat!");
	end

end

function Semi_Frames_Lock(location)
	if ( not InCombatLockdown() ) then
		if location == true then
			InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions);
			InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions);
		end
		Semi_LockDownButtonFrame:Hide();
		SemiCastingBarDragButton:Hide();
		SemiAchievementFrameDragButton:Hide();
		SemiVehicleLeaveDragButton:Hide();
		
		if (not CanExitVehicle()) then
			MainMenuBarVehicleLeaveButton:Hide();
		end
		SemiPlayerPowerBarAltDragButton:Hide();
		SemiExtraActionButtonDragButton:Hide();
		SemiExtraAbilityContainerDragButton:Hide();

		if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
			SFTOTTargetofTargetFrameDragButton:Hide();
		end
		if (IsAddOnLoaded("Semi_Hide_Buffs")) then
			SemiBuffFrameDragButton:SetAlpha(0);
		end
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_MainMenu_BarActionBarDragButton:Hide();
			SemiOverrideActionBarDragButton:Hide();
			if Semi_AB_BL_State then
				Semi_BottomLeft_BarActionBarDragButton:Hide();
			end
			if Semi_AB_BR_State then
				Semi_BottomRight_BarActionBarDragButton:Hide();
			end
			if SF_Bags_State then
				SemiInventoryBagsDragButton:Hide();
			end
			if SF_MicroMenu_State then
				SemiMicroMenuDragButton:Hide();
			end
			SemiPossessBarFrameDragButton:Hide();
			
			if SemiPetBar:IsShown() then
				SemiPetBarDragButton:Hide();
			end
			if StanceButton1:IsShown() then
				SemiStanceBarDragButton:Hide();
			end
		end	
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			local SEB = {
				"SF_EB_1_State",
				"SF_EB_2_State",
				"SF_EB_3_State",
				"SF_EB_4_State",
				"SF_EB_Vert_1_State",
				"SF_EB_Vert_2_State"
			};
			local SEBdrag = {
				"Semi_EB_Bar1",
				"Semi_EB_Bar2",
				"Semi_EB_Bar3",
				"Semi_EB_Bar4",
				"Semi_EB_Vert_Bar1",
				"Semi_EB_Vert_Bar2"
			};
			for i=1,6 do
				if _G[SEB[i]] then
					_G[SEBdrag[i].."ActionBarDragButton"]:Hide();
					
				end
			end
		end

		if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
			SemiGroupLootFrameDragButton:Hide();
		end
	else
		print("Combat Enabled~! Locking of Frames on hold until after combat.");
		print("Kill Quickly~!");
	end
	
end

function Semi_LockDownButtonFrame_OnShow()
	Semi_LockDownButtonFrameTitle:SetText(Semi_LDBF_Title);
	Semi_LockDownButtonFrameButton:SetText(Semi_LDBF_Button);
end

function Semi_LinkCastingBarToDragButton()
	if ( SF_Castbar_State ) and ( SF_Castbar_Ownership) and (not InCombatLockdown()) then
		CastingBarFrame.ignoreFramePositionManager = true;
		CastingBarFrame:ClearAllPoints();
		CastingBarFrame:SetPoint("BOTTOMLEFT", SemiCastingBarDragButton, "BOTTOMLEFT");
	end
end

function Semi_LinkAchievementFrameToDragButton()
	if ( SF_AchievementFrame_Ownership ) and (not InCombatLockdown()) then
		AlertFrame:ClearAllPoints();
		AlertFrame:SetPoint("BOTTOM", SemiAchievementFrameDragButton, "BOTTOM");
	end
end

function Semi_LinkTalkingHeadFrameToDragButton()
	if (not InCombatLockdown()) and (TalkingHeadFrame ~= nil) then
		TalkingHeadFrame:ClearAllPoints();
		TalkingHeadFrame:SetPoint("BOTTOM",SemiAchievementFrameDragButton, "BOTTOM");
		TalkingHeadFrame:SetMovable(true);
		TalkingHeadFrame:SetUserPlaced(true);
		--Personal Code --Begin
		--TalkingHeadFrame:SetScale(.8);
		--Personal Code -- End
	else
		Semi_LinkHeadNow = true;
	end
end
hooksecurefunc("TalkingHead_LoadUI",Semi_LinkTalkingHeadFrameToDragButton);

function Semi_Castbar_Ownership_Options()
	SF_Castbar_Ownership = Semi_CoreOptionsCheckButton18:GetChecked() or false;
		if ( SF_Castbar_Ownership ) then
			Semi_CoreOptionsCheckButton18Text:SetText(Semi_Core_String_CB18a);
			Semi_CoreOptionsCheckButton4:Enable();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
			SF_Castbar_State = true;
			Semi_CoreOptionsCheckButton4:SetChecked(SF_Castbar_State);
			CastingBarFrame:RegisterAllEvents();
			Semi_LinkCastingBarToDragButton();
		elseif (not SF_Castbar_Ownership) then
			CastingBarFrame:RegisterAllEvents();
			CastingBarFrame:ClearAllPoints();
			CastingBarFrame.ignoreFramePositionManager = false;
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4c);
			SF_Castbar_State = false;
			Semi_CoreOptionsCheckButton4:SetChecked(SF_Castbar_State);
			Semi_CoreOptionsCheckButton4:Disable();
			Semi_CoreOptionsCheckButton18Text:SetText(Semi_Core_String_CB18b);
		end
end

function Semi_Castbar_Options()
	SF_Castbar_State = Semi_CoreOptionsCheckButton4:GetChecked() or false;
		if ( SF_Castbar_State ) then
			CastingBarFrame:RegisterAllEvents();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4a);
			Semi_LinkCastingBarToDragButton();
		elseif (not SF_Castbar_State ) then
			CastingBarFrame:Hide();
			CastingBarFrame:UnregisterAllEvents();
			Semi_CoreOptionsCheckButton4Text:SetText(Semi_Core_String_CB4b);
			SemiCastingBarDragButton:Hide();
		end
end

function Semi_AchievementFrame_Ownership_Options()
	SF_AchievementFrame_Ownership = Semi_CoreOptionsCheckButton19:GetChecked() or false;
	if ( SF_AchievementFrame_Ownership ) then
		Semi_CoreOptionsCheckButton19Text:SetText(Semi_Core_String_CB19a);
		Semi_LinkAchievementFrameToDragButton();
	elseif (not SF_AchievementFrame_Ownership) then
		Semi_CoreOptionsCheckButton19Text:SetText(Semi_Core_String_CB19b);
	end
end

function Semi_Gryphons_Options()
	SF_Gryphon_State = Semi_CoreOptionsCheckButton5:GetChecked() or false;
	if Semi_AB_Main_State then
		Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5c);
		Semi_CoreOptionsCheckButton5:SetChecked(not SF_Gryphon_State);
		SF_Gryphon_State = not SF_Gryphon_State;
	else
		if ( SF_Gryphon_State ) then
			MainMenuBarArtFrame.LeftEndCap:Show();
			MainMenuBarArtFrame.RightEndCap:Show();
			Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5a);
		else
			MainMenuBarArtFrame.LeftEndCap:Hide();
			MainMenuBarArtFrame.RightEndCap:Hide();
			Semi_CoreOptionsCheckButton5Text:SetText(Semi_Core_String_CB5b);
		end
	end
end

function Semi_XP_Bar_Options()
	SF_XP_Bar_State = Semi_CoreOptionsCheckButton17:GetChecked() or false;
	if (not Semi_AB_Main_State) then
		if (SF_XP_Bar_State) then
			StatusTrackingBarManager:RegisterAllEvents();
			StatusTrackingBarManager:EnableMouse(true);
			StatusTrackingBarManager:SetAlpha(1);
			StatusTrackingBarManager:Show();
			Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17a);
		elseif (not SF_XP_Bar_State) then
			StatusTrackingBarManager:Hide();
			StatusTrackingBarManager:SetAlpha(0);
			StatusTrackingBarManager:EnableMouse(false);
			StatusTrackingBarManager:UnregisterAllEvents();
			Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17b);
		end
	else
		Semi_CoreOptionsCheckButton17Text:SetText(Semi_Core_String_CB17c);
		Semi_CoreOptionsCheckButton17:SetChecked(not SF_XP_Bar_State);
		SF_XP_Bar_State = not SF_XP_Bar_State;
	end
end

function Semi_Vehicle_Art_Options()
	SF_Vehicle_Art_State = Semi_CoreOptionsCheckButton20:GetChecked() or false;
	if (SF_Vehicle_Art_State) then
		Semi_CoreOptionsCheckButton20Text:SetText(Semi_Core_String_CB20a);
		for i=1,16 do 
			Semi_Vehicle_Texture[i]:Show();
		end
	elseif (not SF_Vehicle_Art_State) then
		Semi_CoreOptionsCheckButton20Text:SetText(Semi_Core_String_CB20b);
		for i=1,16 do
			Semi_Vehicle_Texture[i]:Hide();
		end
	end
end

function Semi_LinkVehicleLeaveButtonToDragButton()
	if (not InCombatLockdown()) then
		UIPARENT_MANAGED_FRAME_POSITIONS["MainMenuBarVehicleLeaveButton"] = nil;
		MainMenuBarVehicleLeaveButton:ClearAllPoints();
		MainMenuBarVehicleLeaveButton:SetPoint("BOTTOMLEFT", SemiVehicleLeaveDragButton, "BOTTOMLEFT");
	end
end

function Semi_LinkPowerBarAltButtonToDragButton()
	if (not InCombatLockdown()) then
		PlayerPowerBarAlt:ClearAllPoints();
		PlayerPowerBarAlt:SetPoint("BOTTOMLEFT", SemiPlayerPowerBarAltDragButton, "BOTTOMLEFT");
		PlayerPowerBarAlt:SetMovable(true);
		PlayerPowerBarAlt:SetUserPlaced(true);
	end
end

function Semi_LinkExtraActionButtonToDragButton()
	
	if (not InCombatLockdown()) then
		ExtraActionBarFrame:EnableMouse(false);
		ExtraActionButton1:ClearAllPoints();
		ExtraActionButton1:SetPoint("BOTTOM", SemiExtraActionButtonDragButton, "BOTTOM");
	end
end

function Semi_LinkExtraAbilityContainerToDragButton()
	if Semi_LinkAbilityNow then
		if (not InCombatLockdown()) then
			if _G["ExtraAbilityContainer"] then
				_G["ExtraAbilityContainer"]:ClearAllPoints();
				_G["ExtraAbilityContainer"].ignoreFramePositionManager = true;
				_G["ExtraAbilityContainer"]:SetPoint("BOTTOM", SemiExtraAbilityContainerDragButton, "BOTTOM");
				Semi_LinkAbilityNow = false;
			end
		end
	end
end

  --Functions for the Modules Menu
--[[
function Semi_NewFeature1_Load_Options()
	SF_NewFeature1_Load = Semi_CoreOptions_ModsCheckButton1:GetChecked() or false;
	if (SF_NewFeature1_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1a);
	end
	if (not SF_NewFeature1_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1b);
	end
	if (SF_NewFeature1_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1c);
	end
	if (not SF_NewFeature1_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton1Text:SetText(Semi_Core_Mods_String_CB1d);
	end
end

function Semi_NewFeature2_Load_Options()
	SF_NewFeature2_Load = Semi_CoreOptions_ModsCheckButton2:GetChecked() or false;
	if (SF_NewFeature2_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2a);
	end
	if (not SF_NewFeature2_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2b);
	end
	if (SF_NewFeature2_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2c);
	end
	if (not SF_NewFeature2_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton2Text:SetText(Semi_Core_Mods_String_CB2d);
	end
end
--]]

function Semi_TargetFrameToT_Load_Options()
	SF_TargetFrameToT_Load = Semi_CoreOptions_ModsCheckButton3:GetChecked() or false;
	if (SF_TargetFrameToT_Load) and (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3a);
	end
	if (not SF_TargetFrameToT_Load) and (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3b);
	end
	if (SF_TargetFrameToT_Load) and (not IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3c);
	end
	if (not SF_TargetFrameToT_Load) and (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
		Semi_CoreOptions_ModsCheckButton3Text:SetText(Semi_Core_Mods_String_CB3d);
	end
end

function Semi_Portrait_Options()
	SF_ClassIcons_Portrait = Semi_CoreOptions_ModsCheckButton4:GetChecked() or false;
	if (SF_ClassIcons_Portrait) and (IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4a);
	end
	if (not SF_ClassIcons_Portrait) and (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4b);
	end
	if (SF_ClassIcons_Portrait) and (not IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4c);
	end
	if (not SF_ClassIcons_Portrait) and (IsAddOnLoaded("Semi_ClassIcons_Portrait")) then
		Semi_CoreOptions_ModsCheckButton4Text:SetText(Semi_Core_Mods_String_CB4d);
	end
end

function Semi_Action_Bars_Options()
	SF_ActionBars_Load = Semi_CoreOptions_ModsCheckButton5:GetChecked() or false;
	if (SF_ActionBars_Load) and (IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5a);
	end
	if (not SF_ActionBars_Load) and (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5b);
	end
	if (SF_ActionBars_Load) and (not IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5c);
	end
	if (not SF_ActionBars_Load) and (IsAddOnLoaded("Semi_Action_Bars")) then
		Semi_CoreOptions_ModsCheckButton5Text:SetText(Semi_Core_Mods_String_CB5d);
	end
end

function Semi_Extra_Bars_Options()
	SF_ExtraBars_Load = Semi_CoreOptions_ModsCheckButton6:GetChecked() or false;
	if (SF_ExtraBars_Load) and (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6a);
	end
	if (not SF_ExtraBars_Load) and (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6b);
	end
	if (SF_ExtraBars_Load) and (not IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6c);
	end
	if (not SF_ExtraBars_Load) and (IsAddOnLoaded("Semi_Extra_Bars")) then
		Semi_CoreOptions_ModsCheckButton6Text:SetText(Semi_Core_Mods_String_CB6d);
	end
end
--[[
function Semi_NewFeature3_Load_Options()
	SF_NewFeature3_Load = Semi_CoreOptions_ModsCheckButton7:GetChecked() or false;
	if (SF_NewFeature3_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7a);
	end
	if (not SF_NewFeature3_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7b);
	end
	if (SF_NewFeature3_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7c);
	end
	if (not SF_NewFeature3_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton7Text:SetText(Semi_Core_Mods_String_CB7d);
	end
end

function Semi_NewFeature4_Load_Options()
	SF_NewFeature4_Load = Semi_CoreOptions_ModsCheckButton8:GetChecked() or false;
	if (SF_NewFeature4_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8a);
	end
	if (not SF_NewFeature4_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8b);
	end
	if (SF_NewFeature4_Load) and (not IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8c);
	end
	if (not SF_NewFeature4_Load) and (IsAddOnLoaded("")) then
		Semi_CoreOptions_ModsCheckButton8Text:SetText(Semi_Core_Mods_String_CB8d);
	end
end
--]]
function Semi_GroupLoot_Frame_Options()
	SF_GroupLoot_Load = Semi_CoreOptions_ModsCheckButton9:GetChecked() or false;
	if (SF_GroupLoot_Load) and (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9a);
	end
	if (not SF_GroupLoot_Load) and (not IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9b);
	end
	if (SF_GroupLoot_Load) and (not IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9c);
	end
	if (not SF_GroupLoot_Load) and (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
		Semi_CoreOptions_ModsCheckButton9Text:SetText(Semi_Core_Mods_String_CB9d);
	end
end

function Semi_ClassColor_Options()
	SF_ClassColor_Load = Semi_CoreOptions_ModsCheckButton10:GetChecked() or false;
	if (SF_ClassColor_Load) and (IsAddOnLoaded("Semi_ClassColor_HealthBar")) then
		Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10a);
	end
	if (not SF_ClassColor_Load) and (not IsAddOnLoaded("Semi_ClassColor_HealthBar")) then
		Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10b);
	end
	if (SF_ClassColor_Load) and (not IsAddOnLoaded("Semi_ClassColor_HealthBar")) then
		Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10c);
	end
	if (not SF_ClassColor_Load) and (IsAddOnLoaded("Semi_ClassColor_HealthBar")) then
		Semi_CoreOptions_ModsCheckButton10Text:SetText(Semi_Core_Mods_String_CB10d);
	end
end

function Semi_ExtraScaling_Options()
	SF_ExtraScaling_Load = Semi_CoreOptions_ModsCheckButton11:GetChecked() or false;
	if (SF_ExtraScaling_Load) and (IsAddOnLoaded("Semi_Extra_Scaling")) then
		Semi_CoreOptions_ModsCheckButton11Text:SetText(Semi_Core_Mods_String_CB11a);
	end
	if (not SF_ExtraScaling_Load) and (not IsAddOnLoaded("Semi_Extra_Scaling")) then
		Semi_CoreOptions_ModsCheckButton11Text:SetText(Semi_Core_Mods_String_CB11b);
	end
	if (SF_ExtraScaling_Load) and (not IsAddOnLoaded("Semi_Extra_Scaling")) then
		Semi_CoreOptions_ModsCheckButton11Text:SetText(Semi_Core_Mods_String_CB11c);
	end
	if (not SF_ExtraScaling_Load) and (IsAddOnLoaded("Semi_Extra_Scaling")) then
		Semi_CoreOptions_ModsCheckButton11Text:SetText(Semi_Core_Mods_String_CB11d);
	end
end

function Semi_MoveObjectiveFrame_Options()
	SF_MoveObjectiveFrame_Load = Semi_CoreOptions_ModsCheckButton12:GetChecked() or false;
	if (SF_MoveObjectiveFrame_Load) and (IsAddOnLoaded("Semi_Move_Objective_Frame")) then
		Semi_CoreOptions_ModsCheckButton12Text:SetText(Semi_Core_Mods_String_CB12a);
	end
	if (not SF_MoveObjectiveFrame_Load) and (not IsAddOnLoaded("Semi_Move_Objective_Frame")) then
		Semi_CoreOptions_ModsCheckButton12Text:SetText(Semi_Core_Mods_String_CB12b);
	end
	if (SF_MoveObjectiveFrame_Load) and (not IsAddOnLoaded("Semi_Move_Objective_Frame")) then
		Semi_CoreOptions_ModsCheckButton12Text:SetText(Semi_Core_Mods_String_CB12c);
	end
	if (not SF_MoveObjectiveFrame_Load) and (IsAddOnLoaded("Semi_Move_Objective_Frame")) then
		Semi_CoreOptions_ModsCheckButton12Text:SetText(Semi_Core_Mods_String_CB12d);
	end
end

function Semi_CoreOptions_Mods_ReloadUI()
	local mod1, mod2, mod3, mod4, mod5, mod6, mod7, mod8, mod9, mod10, mod11, mod12;
	mod1 = Semi_CoreOptions_ModsCheckButton1:GetChecked() or false;
	mod2 = Semi_CoreOptions_ModsCheckButton2:GetChecked() or false;
	mod3 = Semi_CoreOptions_ModsCheckButton3:GetChecked() or false;
	mod4 = Semi_CoreOptions_ModsCheckButton4:GetChecked() or false;
	mod5 = Semi_CoreOptions_ModsCheckButton5:GetChecked() or false;
	mod6 = Semi_CoreOptions_ModsCheckButton6:GetChecked() or false;
	mod7 = Semi_CoreOptions_ModsCheckButton7:GetChecked() or false;
	mod8 = Semi_CoreOptions_ModsCheckButton8:GetChecked() or false;
	mod9 = Semi_CoreOptions_ModsCheckButton9:GetChecked() or false;
	mod10 = Semi_CoreOptions_ModsCheckButton10:GetChecked() or false;
	mod11 = Semi_CoreOptions_ModsCheckButton11:GetChecked() or false;
	mod12 = Semi_CoreOptions_ModsCheckButton12:GetChecked() or false;
	
	if (not mod1) then
		DisableAddOn("Semi_ASR");
	elseif (mod1) then
		EnableAddOn("Semi_ASR");
		LoadAddOn("Semi_ASR");
	end
	
	if (not mod2) then
		DisableAddOn("Semi_Tip");
	elseif (mod2) then
		EnableAddOn("Semi_Tip");
		LoadAddOn("Semi_Tip");
	end

	if (not mod3) then
		DisableAddOn("Semi_TargetofTarget_Frame");
	elseif (mod3) then
		EnableAddOn("Semi_TargetofTarget_Frame");
		LoadAddOn("Semi_TargetofTarget_Frame");
	end

	if  (not mod4) then
		DisableAddOn("Semi_ClassIcons_Portrait");
	elseif (mod4) then
		EnableAddOn("Semi_ClassIcons_Portrait");
		LoadAddOn("Semi_ClassIcons_Portrait");
	end
	
	if (not mod5) then
		DisableAddOn("Semi_Action_Bars");
	elseif (mod5) then
		EnableAddOn("Semi_Action_Bars");
		LoadAddOn("Semi_Action_Bars");
	end
	
	if (not mod6) then
		DisableAddOn("Semi_Extra_Bars");
	elseif (mod6) then
		EnableAddOn("Semi_Extra_Bars");
		LoadAddOn("Semi_Extra_Bars");
	end
	
	if (not mod7) then
		DisableAddOn("Semi_Minimap_Mover");
	elseif (mod7) then
		EnableAddOn("Semi_Minimap_Mover");
		LoadAddOn("Semi_Minimap_Mover");
	end
	if (not mod8) then
		DisableAddOn("Semi_Hide_Buffs");
	elseif (mod8) then
		EnableAddOn("Semi_Hide_Buffs");
		LoadAddOn("Semi_Hide_Buffs");
	end
	
	if (not mod9) then
		DisableAddOn("Semi_GroupLoot_Frame");
	elseif (mod9) then
		EnableAddOn("Semi_GroupLoot_Frame")
		LoadAddOn("Semi_GroupLoot_Frame");
	end
	if (not mod10) then
		DisableAddOn("Semi_ClassColor_HealthBar");
	elseif (mod10) then
		EnableAddOn("Semi_ClassColor_HealthBar");
		LoadAddOn("Semi_ClassColor_HealthBar");
	end
	if (not mod11) then
		DisableAddOn("Semi_Extra_Scaling");
	elseif (mod11) then
		EnableAddOn("Semi_Extra_Scaling");
		LoadAddOn("Semi_Extra_Scaling");
	end
	if (not mod12) then
		DisableAddOn("Semi_Move_Objective_Frame");
	elseif (mod12) then
		EnableAddOn("Semi_Move_Objective_Frame");
		LoadAddOn("Semi_Move_Objective_Frame");
	end
	ReloadUI();
end
-- Slash Commands Handler Function --
function Semi_Core_SlashHandler(msg, editbox)
	local command, rest = msg:match("^(%S*)%s*(.-)$");
	command = string.lower(command);
	if (command == "fix") and IsAddOnLoaded("Semi_Action_Bars") then
		Semi_UpdateBarPositions();
	elseif (command == "menu") then
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions);
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions);
	elseif (command == "scale") then
		InterfaceOptionsFrame_OpenToCategory(Semi_ScaleOptions);
		InterfaceOptionsFrame_OpenToCategory(Semi_ScaleOptions);
	elseif (command == "flyout") and IsAddOnLoaded("Semi_Extra_Bars") then
		InterfaceOptionsFrame_OpenToCategory(Semi_OrientOptions);
		InterfaceOptionsFrame_OpenToCategory(Semi_OrientOptions);
	elseif (command == "mod") or (command == "mods") then
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions_Mods);
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions_Mods);
	elseif (command == "unlock") then
		Semi_Frames_Unlock(false);
	else
		InterfaceOptionsFrame_OpenToCategory("Semi");
		InterfaceOptionsFrame_OpenToCategory("Semi");
	end
end

--Easy Quest Complete -- add macro with the following       /run Semi_QuestComplete_Quick();

function Semi_QuestComplete_Quick()
	if QuestFrame:IsShown() then
		if QuestFrameAcceptButton:IsVisible() then
			QuestFrameAcceptButton:Click();
		end
		if QuestFrameCompleteButton:IsVisible() then
			QuestFrameCompleteButton:Click();
		end
		if QuestFrameCompleteQuestButton:IsVisible() then
			QuestFrameCompleteQuestButton:Click();
		end
	end
	UIErrorsFrame:Clear();
end

function Semi_MapFarm_Driver()
	if MinimapCluster then
	if Semi_MapFarm then
		RegisterStateDriver(MinimapCluster, "visibility", "[combat] hide; show");
		if (IsAddOnLoaded("Semi_Minimap_Mover")) then
			RegisterStateDriver(SemiMinimapClusterDragButton, "visibility", "[combat] hide; show");
		end
		--print(" ");
		--print("Minimap: Farm mode: ON");
		--print(" and will hide when entering combat");
		--print(" ");
	else
		UnregisterStateDriver(MinimapCluster, "visibility");
		if (IsAddOnLoaded("Semi_Minimap_Mover")) then
			UnregisterStateDriver(SemiMinimapClusterDragButton, "visibility");
		end
		--print(" ");
		--print("Minimap: Farm mode: OFF");
		--print(" ");
	end
	end
end


SemiBagStackNum = 2;

function Semi_Container_Reset()
if not Semi_BagReset_State then
	return;
end

local CONTAINER_SCALE = 0.75
local VISIBLE_CONTAINER_SPACING = 3;
local CONTAINER_WIDTH = 192;
local CONTAINER_OFFSET_X = 100;
local CONTAINER_OFFSET_Y = 200;

	if (not InCombatLockdown()) then
		
		local frame, xOffset, yOffset, screenHeight, freeScreenHeight, leftMostPoint, column;
		local screenWidth = GetScreenWidth();
		local containerScale = 1;
		local leftLimit = 0;
		if ( BankFrame:IsShown() ) then
			leftLimit = BankFrame:GetRight() - 25;
		end
	
		while ( containerScale > CONTAINER_SCALE ) do
			screenHeight = GetScreenHeight() / containerScale;
			-- Adjust the start anchor for bags depending on the multibars
			xOffset = CONTAINER_OFFSET_X / containerScale; 
			yOffset = CONTAINER_OFFSET_Y / containerScale; 
			-- freeScreenHeight determines when to start a new column of bags
			freeScreenHeight = screenHeight - yOffset;
			leftMostPoint = screenWidth - xOffset;
			column = 1;
			local frameHeight;
			for index, frameName in ipairs(ContainerFrame1.bags) do
				frameHeight = _G[frameName]:GetHeight();
				if ( freeScreenHeight < frameHeight ) then
					-- Start a new column
					column = column + 1;
					leftMostPoint = screenWidth - ( column * CONTAINER_WIDTH * containerScale ) - xOffset;
					freeScreenHeight = screenHeight - yOffset;
				end
				freeScreenHeight = freeScreenHeight - frameHeight - VISIBLE_CONTAINER_SPACING;
			end
			if ( leftMostPoint < leftLimit ) then
				containerScale = containerScale - 0.01;
			else
				break;
			end
		end
	
		if ( containerScale < CONTAINER_SCALE ) then
			containerScale = CONTAINER_SCALE;
		end
	
		screenHeight = GetScreenHeight() / containerScale;
		-- Adjust the start anchor for bags depending on the multibars
		xOffset = CONTAINER_OFFSET_X / containerScale;
		yOffset = CONTAINER_OFFSET_Y / containerScale;
		-- freeScreenHeight determines when to start a new column of bags
		freeScreenHeight = screenHeight - yOffset;
		column = 0;
		for index, frameName in ipairs(ContainerFrame1.bags) do
			frame = _G[frameName];
			frame:SetScale(containerScale);
			if ( index == 1 ) then
				-- First bag
				frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -xOffset, yOffset );
			else
				if ( index % SemiBagStackNum  == 0 ) or ( freeScreenHeight < frame:GetHeight() ) then
					column = column + 1;
					freeScreenHeight = screenHeight - yOffset;
					frame:SetPoint("BOTTOMRIGHT", frame:GetParent(), "BOTTOMRIGHT", -(column * CONTAINER_WIDTH) - xOffset, yOffset );
				else
					frame:SetPoint("BOTTOMRIGHT", ContainerFrame1.bags[index - 1], "TOPRIGHT", 0, CONTAINER_SPACING);	
				end
			end
			freeScreenHeight = freeScreenHeight - frame:GetHeight() - VISIBLE_CONTAINER_SPACING;
		end
	end
end
hooksecurefunc("UpdateContainerFrameAnchors", Semi_Container_Reset);

--On Event Functions, i.e. what do we do when events happen -- 
function Semi_Core_OnEvent(self, event, ...)
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 = ...;
	if not IsAddOnLoaded("Semi_Core") then
		return;
	end
	if ( event == "PLAYER_REGEN_DISABLED" ) then
		if SemiVehicleLeaveDragButton:IsShown() then
			SemiCastingBarDragButton:SetAlpha(0.1);
			SemiAchievementFrameDragButton:SetAlpha(0.1);
			SemiVehicleLeaveDragButton:SetAlpha(0.1);
			SemiPlayerPowerBarAltDragButton:SetAlpha(0.1);
			SemiExtraActionButtonDragButton:SetAlpha(0.1);
			SemiExtraAbilityContainerDragButton:SetAlpha(0.1);
			if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then
				SemiGroupLootFrameDragButton:SetAlpha(0.1);
			end
			if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then		
				SFTOTTargetofTargetFrameDragButton:SetAlpha(0.1);
			end
		end
	end
	if ( event == "PLAYER_REGEN_ENABLED") then
		if SemiVehicleLeaveDragButton:IsShown() then
			SemiCastingBarDragButton:SetAlpha(1);
			SemiAchievementFrameDragButton:SetAlpha(.75);
			SemiVehicleLeaveDragButton:SetAlpha(1);
			SemiPlayerPowerBarAltDragButton:SetAlpha(1);
			SemiExtraActionButtonDragButton:SetAlpha(1);
			SemiExtraAbilityContainerDragButton:SetAlpha(1);
			if (IsAddOnLoaded("Semi_GroupLoot_Frame")) then 
				SemiGroupLootFrameDragButton:SetAlpha(1);
			end
			if (IsAddOnLoaded("Semi_TargetofTarget_Frame")) then
				SFTOTTargetofTargetFrameDragButton:SetAlpha(.7);
			end

		end
		if ( SF_Castbar_State ) and ( SF_Castbar_Ownership ) then
			Semi_LinkCastingBarToDragButton();
		end
		Semi_LinkVehicleLeaveButtonToDragButton();
		Semi_LinkExtraActionButtonToDragButton();
		if (not UnitInVehicle("player")) then
			Semi_LinkPowerBarAltButtonToDragButton();  --we told UIPARENT_MANAGED_FRAME_POSITIONS to not handle the PlayerPowerBarAlt button, but...
			Semi_Player_Scale_On_Change(Semi_Player_Scale);
			Semi_Pet_Scale_On_Change(Semi_Pet_Scale);
			Semi_Target_Scale_On_Change(Semi_Target_Scale);
			Semi_ToT_Scale_On_Change(Semi_ToT_Scale);
			Semi_PartyFrame_Scale_On_Change(Semi_PartyFrame_Scale);
			Semi_FocusFrame_Scale_On_Change(Semi_FocusFrame_Scale);
			Semi_All_Bars_Scale_On_Change(Semi_AllBars_Scale);
			Semi_VehicleBar_Scale_On_Change(Semi_VehicleBar_Scale)
			if (IsAddOnLoaded("Semi_Action_Bars")) then
				Semi_MicroMenuButtons_Scale_On_Change(Semi_MicroMenuButtons_Scale);
			end
			Semi_PetBar_Scale_On_Change(Semi_PetBar_Scale);
			Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
			if (IsAddOnLoaded("Semi_Extra_Bars")) then
				Semi_EB_Set_Direction("Semi_EB_Bar1Button", Semi_EB_H_1_Orien_Text);
				Semi_EB_Set_Direction("Semi_EB_Bar2Button", Semi_EB_H_2_Orien_Text);
				Semi_EB_Set_Direction("Semi_EB_Bar3Button", Semi_EB_H_3_Orien_Text);
				Semi_EB_Set_Direction("Semi_EB_Bar4Button", Semi_EB_H_4_Orien_Text);
				Semi_EB_Set_Direction("Semi_EB_Vert_Bar1Button", Semi_EB_V_1_Orien_Text);
				Semi_EB_Set_Direction("Semi_EB_Vert_Bar2Button", Semi_EB_V_2_Orien_Text);
			end

			if (IsAddOnLoaded("PlayerXPBar")) then
				Semi_Support_PlayerXPBar_Scale_On_Change(Semi_Support_PlayerXPBar_Scale);
			end
		end
		if (IsAddOnLoaded("Semi_Extra_Scaling")) then
			if Semi_Run_Scale_Reset then
				Semi_FrameNames_Scale_On_Change(Semi_FrameNames_Scale);
				Semi_CollectionsJournal_Scale_On_Change(Semi_CollectionsJournal_Scale);
				Semi_CalendarFrame_Scale_On_Change(Semi_CalendarFrame_Scale);
				Semi_WorldMapFrame_Scale_On_Change(Semi_WorldMapFrame_Scale);
			end
		end
		if Semi_LinkHeadNow then
			Semi_LinkTalkingHeadFrameToDragButton();
		end
		if Semi_LinkAbilityNow then
			Semi_LinkExtraAbilityContainerToDragButton();
		end
	end
	if (event== "ADDON_LOADED" and arg1 == "Semi_Extra_Scaling") then
			-- The following events are for scaling frames that can't be scaled until they are opened and the player is not in combat --
			-- Once that happens, they become unregistered by the mod--
			--Semi_Core_MainFrame:RegisterEvent("TRADE_SKILL_UPDATE");
			Semi_Core_MainFrame:RegisterEvent("CALENDAR_UPDATE_EVENT_LIST");
			Semi_Core_MainFrame:RegisterEvent("INSPECT_READY");
			Semi_Core_MainFrame:RegisterEvent("TRAINER_SHOW");
	end
	if (event == "ADDON_LOADED" and arg1 == "Semi_Core") or event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_LOGIN" then
		if (event == "ADDON_LOADED" and arg1 == "Semi_Core") then
			SlashCmdList["SEMI_CORECOMMAND"] = Semi_Core_SlashHandler;
			SLASH_SEMI_CORECOMMAND1 = "/semi";
			SemiAchievementFrameDragButtonText:SetText(Semi_Achievement_Drag_Text); --This sets the text on the Achievement Frame's drag button, not using tooltip for this one
		end
		if IsAddOnLoaded("Semi_Core") then
			Semi_Initialize_Variables();
		end
		--Semi Personal Code --Begin
		--[[
		if (event == "PLAYER_ENTERING_WORLD") then
			UIErrorsFrame:ClearAllPoints();
			UIErrorsFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 140);
			MirrorTimer1:ClearAllPoints();
			MirrorTimer2:ClearAllPoints();
			MirrorTimer3:ClearAllPoints();
			MirrorTimer1:SetPoint("CENTER", UIParent, "CENTER", 0, 180);
			MirrorTimer2:SetPoint("CENTER", UIParent, "CENTER", 0, 170);
			MirrorTimer3:SetPoint("CENTER", UIParent, "CENTER", 0, 160);
		end
		--]]
		--End of Personal Code --
		if (event == "PLAYER_ENTERING_WORLD") then
			if (IsAddOnLoaded("Semi_Minimap_Mover")) then
				MinimapCluster:SetScale(Semi_MinimapCluster_Scale);
				SemiMinimapClusterDragButton:SetScale(Semi_MinimapCluster_Scale);
			else
				MinimapCluster:ClearAllPoints();
				MinimapCluster:SetScale(Semi_MinimapCluster_Scale);
				MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT",  0, 0);
			end
			Semi_MapFarm_Driver();
		end

		Semi_LinkPowerBarAltButtonToDragButton(); 
		Semi_LinkVehicleLeaveButtonToDragButton();
		Semi_LinkExtraActionButtonToDragButton();
		Semi_LinkExtraAbilityContainerToDragButton();
		
		SemiCastingBarDragButton:Hide();
		SemiAchievementFrameDragButton:Hide();
		SemiVehicleLeaveDragButton:Hide();
		SemiPlayerPowerBarAltDragButton:Hide();
		SemiExtraActionButtonDragButton:Hide();
		SemiExtraAbilityContainerDragButton:Hide();
		
		if (SF_MiniMapChoice_Load) then
			Semi_Core_MinimapButton_Reposition();
		elseif (not SF_MiniMapChoice_Load) then
			Semi_CoreMinimapButton:Hide();
		end
		
	
		if ( SF_Castbar_State ) and ( SF_Castbar_Ownership) then
			Semi_LinkCastingBarToDragButton();
		elseif (not SF_Castbar_State ) and ( SF_Castbar_Ownership) then
			CastingBarFrame:Hide();
			CastingBarFrame:UnregisterAllEvents();
		end
		if (not SF_Gryphon_State) then
			MainMenuBarArtFrame.LeftEndCap:Hide();
			MainMenuBarArtFrame.RightEndCap:Hide();
		else
			MainMenuBarArtFrame.LeftEndCap:Show();
			MainMenuBarArtFrame.RightEndCap:Show();
		end
		if (SF_XP_Bar_State) then
			StatusTrackingBarManager:RegisterAllEvents();
			StatusTrackingBarManager:EnableMouse(true);
			StatusTrackingBarManager:SetAlpha(1);
			StatusTrackingBarManager:Show();
		else
			StatusTrackingBarManager:SetAlpha(0);
			StatusTrackingBarManager:EnableMouse(false);
			StatusTrackingBarManager:Hide();
			StatusTrackingBarManager:UnregisterAllEvents();
		end

		if (SF_Vehicle_Art_State) then
			
			for i=1,16 do 
				Semi_Vehicle_Texture[i]:Show();
			end
		elseif (not SF_Vehicle_Art_State) then
			
			for i=1,16 do 
				Semi_Vehicle_Texture[i]:Hide();
			end
		end
		Semi_Player_Scale_On_Change(Semi_Player_Scale);
		Semi_Pet_Scale_On_Change(Semi_Pet_Scale);
		Semi_Target_Scale_On_Change(Semi_Target_Scale);
		Semi_ToT_Scale_On_Change(Semi_ToT_Scale);
		Semi_PartyFrame_Scale_On_Change(Semi_PartyFrame_Scale);
		Semi_FocusFrame_Scale_On_Change(Semi_FocusFrame_Scale);
		Semi_All_Bars_Scale_On_Change(Semi_AllBars_Scale);
		Semi_VehicleBar_Scale_On_Change(Semi_VehicleBar_Scale);
		Semi_PetBattleFrame_Scale_On_Change(Semi_PetBattleFrame_Scale);
		if (IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_MicroMenuButtons_Scale_On_Change(Semi_MicroMenuButtons_Scale);
			SetMenuBarScale(Semi_AllBars_Scale);
			Semi_PetBar_Scale_On_Change(Semi_PetBar_Scale);
		end
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			SetExtraBarScale(Semi_AllBars_Scale);
		end
		if (IsAddOnLoaded("Semi_Extra_Scaling")) then
			Semi_FrameNames_Scale_On_Change(Semi_FrameNames_Scale);
			Semi_CollectionsJournal_Scale_On_Change(Semi_CollectionsJournal_Scale);
			Semi_CalendarFrame_Scale_On_Change(Semi_CalendarFrame_Scale);
			Semi_WorldMapFrame_Scale_On_Change(Semi_WorldMapFrame_Scale);
		end
		if IsAddOnLoaded("Semi_Move_Objective_Frame") then
			Semi_LinkObjectiveFrameToDragButton();
			Semi_ObjectiveFrame_Scale_On_Change(Semi_ObjectiveFrame_Scale);
		end

		Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
		Semi_GroupLootFrame_Scale_On_Change(Semi_GroupLootFrame_Scale);

		if (IsAddOnLoaded("PlayerXPBar")) and (event == "PLAYER_ENTERING_WORLD") then
			Semi_Support_PlayerXPBar_Scale_On_Change(Semi_Support_PlayerXPBar_Scale);
		end
	end
	if (event == "UNIT_EXITED_VEHICLE") and (not InCombatLockdown()) and ((CharacterMicroButton:GetParent():GetName()) == "MainMenuBarArtFrame") then
		Semi_Player_Scale_On_Change(Semi_Player_Scale);
		Semi_Pet_Scale_On_Change(Semi_Pet_Scale);
		Semi_Target_Scale_On_Change(Semi_Target_Scale);
		Semi_ToT_Scale_On_Change(Semi_ToT_Scale);
		Semi_PartyFrame_Scale_On_Change(Semi_PartyFrame_Scale);
		Semi_FocusFrame_Scale_On_Change(Semi_FocusFrame_Scale);
		Semi_All_Bars_Scale_On_Change(Semi_AllBars_Scale);
		Semi_VehicleBar_Scale_On_Change(Semi_VehicleBar_Scale);

		if (IsAddOnLoaded("Semi_Action_Bars")) then
			Semi_MicroMenuButtons_Scale_On_Change(Semi_MicroMenuButtons_Scale);
		end
		Semi_PetBar_Scale_On_Change(Semi_PetBar_Scale);
		Semi_BossTargetFrames_Scale_On_Change(Semi_BossTargetFrame_Scale);
		if (IsAddOnLoaded("Semi_Extra_Bars")) then
			Semi_EB_Set_Direction("Semi_EB_Bar1Button", Semi_EB_H_1_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Bar2Button", Semi_EB_H_2_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Bar3Button", Semi_EB_H_3_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Bar4Button", Semi_EB_H_4_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Vert_Bar1Button", Semi_EB_V_1_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Vert_Bar2Button", Semi_EB_V_2_Orien_Text);
		end

		if (IsAddOnLoaded("PlayerXPBar")) then
			Semi_Support_PlayerXPBar_Scale_On_Change(Semi_Support_PlayerXPBar_Scale);
		end		
	end

	if (event == "PET_BATTLE_OPENING_START") then
		for i=1,12 do 
			SemiMicroMenuButtons[i]:SetScale(1);
		end	
	end
	if (event == "UNIT_ENTERED_VEHICLE") then
		--DEFAULT_CHAT_FRAME:AddMessage("UNIT_ENTERED_VEHICLE fired!");
		Semi_LinkVehicleLeaveButtonToDragButton();
	end
	if (event == "UNIT_ENTERING_VEHICLE") then
		--DEFAULT_CHAT_FRAME:AddMessage("UNIT_ENTERING_VEHICLE fired!");
		Semi_LinkVehicleLeaveButtonToDragButton();
	end

	if (event == "UPDATE_BONUS_ACTIONBAR") then
		--DEFAULT_CHAT_FRAME:AddMessage("UPDATE_BONUS_ACTIONBAR fired!");
		if UnitOnTaxi("player") then
			--DEFAULT_CHAT_FRAME:AddMessage("It Knows I'm on a Taxi!");
			Semi_LinkVehicleLeaveButtonToDragButton();
		end
	end
	--The Following Events will only be fired if they have been registered by Semi_Extra_Scaling to be tracked
	--otherwise, they get ignored
		if (event == "TRADE_SKILL_UPDATE") then		--I don't like this option, this is going to cause a lot of wasted cycles
			--print("Trade Skill Update has Fired!");
			if (TradeSkillFrame ~= nil) and  (not InCombatLockdown()) then
				TradeSkillFrame:SetScale(Semi_FrameNames_Scale);
				Semi_Core_MainFrame:UnregisterEvent("TRADE_SKILL_UPDATE"); --this should release the event from being watched and ease up on the cycles once we set the scale
			end
		end
		if (event == "INSPECT_READY") then
			--print("Inspect Ready has Fired!");
			if (InspectFrame ~= nil) and (not InCombatLockdown()) then
				InspectFrame:SetScale(Semi_FrameNames_Scale);
				Semi_Core_MainFrame:UnregisterEvent("INSPECT_READY");
			end
		end
		if (event == "CALENDAR_UPDATE_EVENT_LIST") then
			--print("Calendar Update Event List has Fired!");
			if (CalendarFrame ~= nil) and (not InCombatLockdown()) then
				CalendarFrame:SetScale(Semi_CalendarFrame_Scale);
				Semi_Core_MainFrame:UnregisterEvent("CALENDAR_UPDATE_EVENT_LIST");
			end
		end
		if (event == "TRAINER_SHOW") then
			if (ClassTrainerFrame ~= nil) and (not InCombatLockdown()) then
				ClassTrainerFrame:SetScale(Semi_FrameNames_Scale);
				Semi_Core_MainFrame:UnregisterEvent("TRAINER_SHOW");
			end
		end
		
	if (event == "PLAYER_LOGIN") then
		Semi_Load_Char_Frames();
	end
	if (event == "PLAYER_LOGOUT") then
		for k, v in pairs(Semi_Variable_Table["Default"]) do
			Semi_Variable_Table[Semirealm][Semichar][k] = _G[k]
		end
		Semi_Save_Char_Frames();
	end
end

function Semi_Save_Variables()
	for k, v in pairs(Semi_Variable_Table["Global"]) do
		Semi_Variable_Table[Semirealm][Semichar][k] = _G[k]
	end
end

function Semi_MiniMap_Choice_Options(self)
	SF_MiniMapChoice_Load = self:GetChecked() or false;
	if SF_MiniMapChoice_Load then
		_G[self:GetName().."Text"]:SetText(Semi_MiniMap_Choice_Yes);
		Semi_CoreMinimapButton:Show();
		Semi_Core_MinimapButton_Reposition();
	elseif (not SF_MiniMapChoice_Load) then
		_G[self:GetName().."Text"]:SetText(Semi_MiniMap_Choice_No);
		Semi_CoreMinimapButton:Hide();
		Semi_Core_MinimapPos = "";
	end
end

function Semi_Core_MinimapButton_Reposition()
	if (Semi_Core_MinimapPos == "" or Semi_Core_MinimapPos == "nil" or Semi_Core_MinimapPos == nil) then
		Semi_Core_MinimapPos = 45;
	end
	Semi_CoreMinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(Semi_Core_MinimapPos)),(80*sin(Semi_Core_MinimapPos))-52);
end

function Semi_CoreMinimapButton_DraggingFrame_OnUpdate(self)

	local xpos, ypos = GetCursorPosition();
	local xmin = Minimap:GetLeft();
	local ymin = Minimap:GetBottom();

	xpos = (xmin-xpos/self:GetEffectiveScale()+70); -- get coordinates as differences from the center of the minimap
	ypos = (ypos/self:GetEffectiveScale()-ymin-70);

	Semi_Core_MinimapPos = (math.deg(math.atan2(ypos,xpos))); -- save the degrees we are relative to the minimap center
	Semi_Core_MinimapButton_Reposition(); -- move the button
end

function Semi_CoreMinimapButton_LeftClick()
	if ( not InCombatLockdown() ) then
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions);
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions);
	end
end

function Semi_CoreMinimapButton_RightClick()
	if (not InCombatLockdown()) then
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions_Mods);
		InterfaceOptionsFrame_OpenToCategory(Semi_CoreOptions_Mods);
	end
end

function Semi_CoreMinimapButton_MiddleClick()
	if (not InCombatLockdown()) then
		InterfaceOptionsFrame_OpenToCategory(Semi_ScaleOptions);
		InterfaceOptionsFrame_OpenToCategory(Semi_ScaleOptions);
	end
end

--Bar Functions--Begin

function SetPetBarScale(scale)
	if (not InCombatLockdown()) then
		for i=1, 10 do
			_G["PetActionButton"..i]:SetScale(scale);
		end
	end
end

function SetMenuBarScale(scale)
	if (not InCombatLockdown()) then
		if _G["Semi_MainMenu_Bar"] then
			Semi_MainMenu_Bar:SetScale(scale);
			Semi_MainMenu_BarActionBarDragButton:SetScale(scale);
			Semi_BottomRight_Bar:SetScale(scale);
			Semi_BottomRight_BarActionBarDragButton:SetScale(scale);
			Semi_BottomLeft_Bar:SetScale(scale);
			Semi_BottomLeft_BarActionBarDragButton:SetScale(scale);
		end
	end
end

function Semi_LinkDrag(bar, relativeTo, point, relativePoint)
	if (not InCombatLockdown()) then
		bar:ClearAllPoints();
		bar:SetPoint(point, relativeTo, relativePoint);
		bar:Show();
		bar:EnableMouse(true);
	end
end

function Semi_Bar_ShowHide(bar, visible)
	if visible then
		_G[bar]:Show();
		if Semi_LockDownButtonFrame:IsVisible() then
			_G[bar.."ActionBarDragButton"]:Show();
		else
			_G[bar.."ActionBarDragButton"]:Hide();
		end
	else
		_G[bar]:Hide();
		_G[bar.."ActionBarDragButton"]:Hide();
	end
end

function Semi_Bar_StateDriver(bar, barstate, vehiclechoice)
	local Semi_Visible_Option;
	if vehiclechoice then
		Semi_Visible_Option = "[petbattle]hide;show"
	else
		Semi_Visible_Option = "[petbattle] hide; [vehicleui] hide; [overridebar] hide; [shapeshift] hide; show"
	end
	
	if barstate then
		RegisterStateDriver(_G[bar], "visibility", Semi_Visible_Option)
	else
		UnregisterStateDriver(_G[bar], "visibility")
	end
	Semi_Bar_ShowHide(bar, barstate)
end
--Bar Functions--End

local Semi_Variable_Default = {
		Semi_Core_MinimapPos = 45,
		SF_MiniMapChoice_Load = true,
		Semi_MinimapCluster_Scale = 1.0,
		SF_Castbar_State = true,
		SF_Castbar_Ownership = true,
		SF_AchievementFrame_Ownership = true,
		SF_Gryphon_State = true,
		SF_XP_Bar_State = true,
		SF_Vehicle_Art_State = true,
		SF_Bags_State = true,
		Semi_BagReset_State = false,
		SF_MicroMenu_State = true,
		SF_MainMenuBarGrid_State = true,
		Semi_AB_Main_State = true,
		Semi_AB_BL_State = true,
		Semi_AB_BR_State = true,
		Semi_AB_Vehicle = false,
		SF_EB_1_State = true,
		SF_EB_2_State = true,
		SF_EB_3_State = true,
		SF_EB_4_State = true,
		SF_EB_Vert_1_State = false,
		SF_EB_Vert_2_State = false,
		Semi_EB_Grid = true,
		SF_Grid_State = true,		
		SF_MoveObjectiveFrame_Load	= true,	
		Semi_Player_Scale = 1.0,
		Semi_RuneFrame_Scale = 1.0,
		Semi_Pet_Scale = 1.0,
		Semi_Target_Scale = 1.0,
		Semi_ToT_Scale = 1.0,
		Semi_AllBars_Scale = 1.0,
		Semi_MicroMenuButtons_Scale = 1.0,
		Semi_FrameNames_Scale = 1.0,
		Semi_CollectionsJournal_Scale = 1.0,
		Semi_CalendarFrame_Scale = 1.0,
		Semi_VehicleBar_Scale = 0.75,
		Semi_WorldMapFrame_Scale = 1.0,		
		Semi_PetBattleFrame_Scale = 0.8,
		Semi_PetBar_Scale = 1.0,
		Semi_Support_PlayerXPBar_Scale = 1.0,
		Semi_PartyFrame_Scale = 1.0,
		Semi_FocusFrame_Scale = 1.0,
		Semi_BossTargetFrame_Scale = 1.0,
		Semi_GroupLootFrame_Scale = 1.0,		
		Semi_ObjectiveFrame_Scale = 1.0,
		Semi_Objective_Frame_Height = 500,
		Semi_EB_Vehicle = false,
		Semi_EB_H_1_Orien_Text = "UP",
		Semi_EB_H_2_Orien_Text = "UP",
		Semi_EB_H_3_Orien_Text = "UP",
		Semi_EB_H_4_Orien_Text = "UP",
		Semi_EB_V_1_Orien_Text = "LEFT",
		Semi_EB_V_2_Orien_Text = "LEFT",
		Semi_MapFarm = false
	};
	
function Semi_Load_Class_Frames()
	if Semi_Variable_Table["Frames"] ~= nil then
		if Semi_Variable_Table["Frames"][Semiclass] ~= nil then
			for k,v in pairs(Semi_Variable_Table["Frames"][Semiclass]) do
				if _G[k] ~= nil then
					_G[k]:ClearAllPoints();
					_G[k]:SetMovable(true);
					local point, relativeTo, relativePoint, xOfs, yOfs;
					point = Semi_Variable_Table["Frames"][Semiclass][k]["point"];
					relativeTo = Semi_Variable_Table["Frames"][Semiclass][k]["relativeTo"];
					relativePoint = Semi_Variable_Table["Frames"][Semiclass][k]["relativePoint"];
					xOfs = Semi_Variable_Table["Frames"][Semiclass][k]["xOfs"];
					yOfs = Semi_Variable_Table["Frames"][Semiclass][k]["yOfs"];
					if relativeTo ~= "nil" then 
						_G[k]:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);
					else
						_G[k]:SetPoint(point, nil, relativePoint, xOfs, yOfs);
					end
				end
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("No Semi Frame Class Positions Saved")
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("No Semi Frame Positions Saved")
	end
end

function Semi_Save_Class_Frames()
	for k, v in pairs(Semi_Variable_Table["Frames"]["Default"]) do
		if _G[v] ~= nil then
				
				point, relativeTo, relativePoint, xOfs, yOfs = _G[v]:GetPoint();
				
				if Semi_Variable_Table["Frames"][Semiclass] == nil then
					Semi_Variable_Table["Frames"][Semiclass] = {};
				end
				if Semi_Variable_Table["Frames"][Semiclass][v] == nil then
					Semi_Variable_Table["Frames"][Semiclass][v] = {};
				end
				
				
				Semi_Variable_Table["Frames"][Semiclass][v]["point"] = point; 
				if relativeTo ~= nil then 
					Semi_Variable_Table["Frames"][Semiclass][v]["relativeTo"] = relativeTo:GetName();
				else 
					Semi_Variable_Table["Frames"][Semiclass][v]["relativeTo"] = "nil";
				end
				Semi_Variable_Table["Frames"][Semiclass][v]["relativePoint"] = relativePoint;
				Semi_Variable_Table["Frames"][Semiclass][v]["xOfs"] = xOfs;
				Semi_Variable_Table["Frames"][Semiclass][v]["yOfs"] = yOfs;				
		end
	end
	
end
	
function Semi_Load_Global_Frames()
	if Semi_Variable_Table["Frames"] ~= nil then
		--Semi_Variable_Table[Semirealm][Semichar] = Semi_Variable_Table["Global"];
		--Semi_Player = Semi_Variable_Table[Semirealm][Semichar];
		for k,v in pairs(Semi_Variable_Table["Frames"]["Global"]) do
				if _G[k] ~= nil then
					_G[k]:ClearAllPoints();
					_G[k]:SetMovable(true);
					local point, relativeTo, relativePoint, xOfs, yOfs;
					point = Semi_Variable_Table["Frames"]["Global"][k]["point"];
					relativeTo = Semi_Variable_Table["Frames"]["Global"][k]["relativeTo"];
					relativePoint = Semi_Variable_Table["Frames"]["Global"][k]["relativePoint"];
					xOfs = Semi_Variable_Table["Frames"]["Global"][k]["xOfs"];
					yOfs = Semi_Variable_Table["Frames"]["Global"][k]["yOfs"];
					if relativeTo ~= "nil" then 
						_G[k]:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);
					else
						_G[k]:SetPoint(point, nil, relativePoint, xOfs, yOfs);
					end
				end
		end
		--ReloadUI(); --change
		--return Semi_Player;
	else
		DEFAULT_CHAT_FRAME:AddMessage("No Semi Frame Global Positions Saved")
	end
end

function Semi_Save_Global_Frames()
	
	--local frame = Semi_Frames_DragButton
	for k, v in pairs(Semi_Variable_Table["Frames"]["Default"]) do
		--DEFAULT_CHAT_FRAME:AddMessage(SemiDragButtons[i]:GetName());
		--DEFAULT_CHAT_FRAME:AddMessage(v);
		if _G[v] ~= nil then
				
				point, relativeTo, relativePoint, xOfs, yOfs = _G[v]:GetPoint();
				
				if Semi_Variable_Table["Frames"]["Global"] == nil then
					Semi_Variable_Table["Frames"]["Global"] = {};
				end
				if Semi_Variable_Table["Frames"]["Global"][v] == nil then
					Semi_Variable_Table["Frames"]["Global"][v] = {};
				end
				
				
				Semi_Variable_Table["Frames"]["Global"][v]["point"] = point; 
				if relativeTo ~= nil then 
					Semi_Variable_Table["Frames"]["Global"][v]["relativeTo"] = relativeTo:GetName();
				else 
					Semi_Variable_Table["Frames"]["Global"][v]["relativeTo"] = "nil";
				end
				Semi_Variable_Table["Frames"]["Global"][v]["relativePoint"] = relativePoint;
				Semi_Variable_Table["Frames"]["Global"][v]["xOfs"] = xOfs;
				Semi_Variable_Table["Frames"]["Global"][v]["yOfs"] = yOfs;				
		end
	end
	
end

function Semi_Load_Char_Frames()
	if Semi_Variable_Table["Frames"] ~= nil then
	 if Semi_Variable_Table["Frames"][Semirealm] ~= nil then
	  if Semi_Variable_Table["Frames"][Semirealm][Semichar] ~= nil then
		for k,v in pairs(Semi_Variable_Table["Frames"][Semirealm][Semichar]) do
				if _G[k] ~= nil then
					_G[k]:ClearAllPoints();
					_G[k]:SetMovable(true);
					local point, relativeTo, relativePoint, xOfs, yOfs;
					point = Semi_Variable_Table["Frames"][Semirealm][Semichar][k]["point"];
					relativeTo = Semi_Variable_Table["Frames"][Semirealm][Semichar][k]["relativeTo"];
					relativePoint = Semi_Variable_Table["Frames"][Semirealm][Semichar][k]["relativePoint"];
					xOfs = Semi_Variable_Table["Frames"][Semirealm][Semichar][k]["xOfs"];
					yOfs = Semi_Variable_Table["Frames"][Semirealm][Semichar][k]["yOfs"];
					if relativeTo ~= "nil" then 
						_G[k]:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);
					else
						_G[k]:SetPoint(point, nil, relativePoint, xOfs, yOfs);
					end
					_G[k]:SetUserPlaced(true);
				end
		end
	  end
	 end
	end
end

function Semi_Save_Char_Frames()
	
	--local frame = Semi_Frames_DragButton
	for k, v in pairs(Semi_Variable_Table["Frames"]["Default"]) do
		if _G[v] ~= nil then
				
				local point, relativeTo, relativePoint, xOfs, yOfs = _G[v]:GetPoint();
				
				if Semi_Variable_Table["Frames"][Semirealm] == nil then
					Semi_Variable_Table["Frames"][Semirealm] = {};
				end
				if Semi_Variable_Table["Frames"][Semirealm][Semichar] == nil then
					Semi_Variable_Table["Frames"][Semirealm][Semichar] = {};
				end
				
				if Semi_Variable_Table["Frames"][Semirealm][Semichar][v] == nil then
					Semi_Variable_Table["Frames"][Semirealm][Semichar][v] = {};
				end
				
				
				Semi_Variable_Table["Frames"][Semirealm][Semichar][v]["point"] = point; 
				if relativeTo ~= nil then 
					Semi_Variable_Table["Frames"][Semirealm][Semichar][v]["relativeTo"] = relativeTo:GetName();
				else 
					Semi_Variable_Table["Frames"][Semirealm][Semichar][v]["relativeTo"] = "nil";
				end
				Semi_Variable_Table["Frames"][Semirealm][Semichar][v]["relativePoint"] = relativePoint;
				Semi_Variable_Table["Frames"][Semirealm][Semichar][v]["xOfs"] = xOfs;
				Semi_Variable_Table["Frames"][Semirealm][Semichar][v]["yOfs"] = yOfs;				
		end
	end
	
end
	
function Semi_Load_Global()
	if Semi_Variable_Table["Global"] ~= nil then
		Semi_Variable_Table[Semirealm][Semichar] = Semi_Variable_Table["Global"];
		--Semi_Player = Semi_Variable_Table[Semirealm][Semichar];
		for k, v in pairs(Semi_Variable_Table[Semirealm][Semichar]) do
			_G[k] = v
		end
		ReloadUI();
	else
		DEFAULT_CHAT_FRAME:AddMessage("No Semi Globals Saved")
	end
end

function Semi_Save_Global()
	if Semi_Variable_Table["Global"] == nil then
		Semi_Variable_Table["Global"] = {};
	end
	for k, v in pairs(Semi_Variable_Table[Semirealm][Semichar]) do
			Semi_Variable_Table["Global"][k] = _G[k]
	end
	--Semi_Variable_Table[Global] = Semi_Player;
end

function Semi_Load_Default()
	Semi_Variable_Table[Semirealm][Semichar] = Semi_Variable_Default;
	for k, v in pairs(Semi_Variable_Table[Semirealm][Semichar]) do
		_G[k] = v
	end
end


function Semi_Initialize_Variables()
	local SemiDragButtons = {
	"Semi_MainMenu_BarActionBarDragButton",
	"Semi_BottomLeft_BarActionBarDragButton",
	"Semi_BottomRight_BarActionBarDragButton",
	"SemiCastingBarDragButton",
	"SemiStanceBarDragButton",
	"SemiVehicleLeaveDragButton",
	"SemiPlayerPowerBarAltDragButton",
	"SemiExtraActionButtonDragButton",
	"SemiExtraAbilityContainerDragButton",
	"SemiGroupLootFrameDragButton",
	"SFTOTTargetofTargetFrameDragButton",
	"SemiInventoryBagsDragButton",
	"SemiMicroMenuDragButton",
	"SemiPossessBarFrameDragButton",
	"Semi_EB_Bar1ActionBarDragButton",
	"Semi_EB_Bar2ActionBarDragButton",
	"Semi_EB_Bar3ActionBarDragButton",
	"Semi_EB_Bar4ActionBarDragButton",
	"Semi_EB_Vert_Bar1ActionBarDragButton",
	"Semi_EB_Vert_Bar2ActionBarDragButton",
	"SemiObjectiveFrameDragButton",
	"SemiMinimapClusterDragButton",
	"SemiOverrideActionBarDragButton",
	"SemiPetBarDragButton", --24
}
	
	if (not Semi_Variable_Table) then -- 1st time loading addon ever 
		Semi_Variable_Table = {};
	end
	
	if (not Semi_Variable_Table["Default"]) then
		Semi_Variable_Table["Default"] = {};
	end
	for k, v in pairs(Semi_Variable_Default) do
		if (Semi_Variable_Table["Default"][k]) == nil then
			Semi_Variable_Table["Default"][k] = Semi_Variable_Default[k];
		end
	end
	
	if (not Semi_Variable_Table[Semirealm]) then -- initialize realm
		Semi_Variable_Table[Semirealm] = {};
	end
	
	if (not Semi_Variable_Table[Semirealm][Semichar]) then -- initialize character
		Semi_Variable_Table[Semirealm][Semichar] = Semi_Variable_Table["Default"];
	end
	
	for k, v in pairs(Semi_Variable_Table["Default"]) do
		if (Semi_Variable_Table[Semirealm][Semichar][k] == nil) then
			Semi_Variable_Table[Semirealm][Semichar][k] = Semi_Variable_Table["Default"][k];
		end
	end
	
	if Semi_Variable_Table["Frames"] == nil then
		Semi_Variable_Table["Frames"] = {};
	end
	if Semi_Variable_Table["Frames"]["Default"] == nil then
		Semi_Variable_Table["Frames"]["Default"] = {};
	end
	for k=1,24 do
		if Semi_Variable_Table["Frames"]["Default"][SemiDragButtons[k]] == nil then
			Semi_Variable_Table["Frames"]["Default"][k] = SemiDragButtons[k];
		end	
	end
	if Semi_Variable_Table["Frames"][Semirealm] == nil then
		Semi_Variable_Table["Frames"][Semirealm] = {};
	end
	if Semi_Variable_Table["Frames"][Semirealm][Semichar] == nil then
		Semi_Variable_Table["Frames"][Semirealm][Semichar] = {};
	end
	
	for k, v in pairs(Semi_Variable_Table[Semirealm][Semichar]) do
		_G[k] = v
	end
	
end