Semi_Run_Scale_Reset = false;

--New Frames
local Semi_Garrison_FrameNames = {
	GarrisonBuildingFrame,
	GarrisonMissionFrame,
	GarrisonLandingPage,
	GarrisonMonumentFrame,
	GarrisonRecruiterFrame,
	GarrisonRecruitSelectFrame,
	GarrisonCapacitiveDisplayFrame
};

local Semi_FrameNames = {
	GossipFrame,
	QuestFrame,
	QuestLogPopupDetailFrame,
	BankFrame,
	DressUpFrame,
	MailFrame,
	OpenMailFrame,
	CharacterFrame,
	SpellBookFrame,
	MerchantFrame,
	FriendsFrame,
	ItemTextFrame,
	PVEFrame,
	TradeFrame,
	HelpPlate,
	GuildRegistrarFrame,
	PetitionFrame,
	TaxiFrame,
	PetStableFrame,
	LootFrame
};

function Semi_FrameNames_Slider()
	CreateFrame("Slider", "SemiFrameNamesScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiFrameNamesScaleSlider:ClearAllPoints();
	SemiFrameNamesScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -200);
	SemiFrameNamesScaleSlider:SetMinMaxValues(0.25, 2.5);
	SemiFrameNamesScaleSlider:SetValueStep(0.05);
	SemiFrameNamesScaleSlider:SetValue(Semi_FrameNames_Scale);
	SemiFrameNamesScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_FrameNames_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[SemiFrameNamesScaleSlider:GetName().."Text"]:SetText("Multiple Frames:  "..Semi_FrameNames_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiFrameNamesScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[SemiFrameNamesScaleSlider:GetName().."High"]:SetText("2.5");
	_G[SemiFrameNamesScaleSlider:GetName().."Text"]:SetText("Multiple Frames:  "..Semi_FrameNames_Scale);
	SemiFrameNamesScaleSlider:Show();
end

function Semi_CalendarFrame_Slider()
	CreateFrame("Slider", "SemiCalendarFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiCalendarFrameScaleSlider:ClearAllPoints();
	SemiCalendarFrameScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -250);
	SemiCalendarFrameScaleSlider:SetMinMaxValues(0.25, 2.5);
	SemiCalendarFrameScaleSlider:SetValueStep(0.05);
	SemiCalendarFrameScaleSlider:SetValue(Semi_CalendarFrame_Scale);
	SemiCalendarFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_CalendarFrame_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[SemiCalendarFrameScaleSlider:GetName().."Text"]:SetText("Calendar Frame:  "..Semi_CalendarFrame_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiCalendarFrameScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[SemiCalendarFrameScaleSlider:GetName().."High"]:SetText("2.5");
	_G[SemiCalendarFrameScaleSlider:GetName().."Text"]:SetText("Calendar Frame:  "..Semi_CalendarFrame_Scale);
	SemiCalendarFrameScaleSlider:Show();
end

function Semi_WorldMapFrame_Slider()
	CreateFrame("Slider", "SemiWorldMapFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiWorldMapFrameScaleSlider:ClearAllPoints();
	SemiWorldMapFrameScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -300);
	SemiWorldMapFrameScaleSlider:SetMinMaxValues(0.25, 2.5);
	SemiWorldMapFrameScaleSlider:SetValueStep(0.05);
	SemiWorldMapFrameScaleSlider:SetValue(Semi_WorldMapFrame_Scale);
	SemiWorldMapFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_WorldMapFrame_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[SemiWorldMapFrameScaleSlider:GetName().."Text"]:SetText("World Map Frame:  "..Semi_WorldMapFrame_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiWorldMapFrameScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[SemiWorldMapFrameScaleSlider:GetName().."High"]:SetText("2.5");
	_G[SemiWorldMapFrameScaleSlider:GetName().."Text"]:SetText("World Map Frame:  "..Semi_WorldMapFrame_Scale);
	SemiWorldMapFrameScaleSlider:Show();
end

function Semi_FrameNames_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_FrameNames_Scale = PassedValueFromSliderOrEvent;
	for i=1,20 do --total number of frame names in the array
		Semi_FrameNames[i]:SetScale(Semi_FrameNames_Scale);
	end
	if MacroFrame then
		MacroFrame:SetScale(Semi_FrameNames_Scale)
	end
	if TradeSkillFrame then
		TradeSkillFrame:SetScale(Semi_FrameNames_Scale)
	end
	if GuildFrame then
		GuildFrame:SetScale(Semi_FrameNames_Scale)
	end
	if InspectFrame then
		InspectFrame:SetScale(Semi_FrameNames_Scale)
	end
	if ClassTrainerFrame then
		ClassTrainerFrame:SetScale(Semi_FrameNames_Scale)
	end
	if LookingForGuildFrame then
		LookingForGuildFrame:SetScale(Semi_FrameNames_Scale)
	end
	--if PVPUIFrame then
	--	PVPUIFrame:SetScale(Semi_FrameNames_Scale)
	--end
	if ArchaeologyFrame then
		ArchaeologyFrame:SetScale(Semi_FrameNames_Scale)
	end
	if PlayerTalentFrame then
		PlayerTalentFrame:SetScale(Semi_FrameNames_Scale)
	end
	if EncounterJournal then
		EncounterJournal:SetScale(Semi_FrameNames_Scale)
	end
	if ReforgingFrame then
		ReforgingFrame:SetScale(Semi_FrameNames_Scale)
	end
	if ItemUpgradeFrame then
		ItemUpgradeFrame:SetScale(Semi_FrameNames_Scale)
	end
	if TransmogrifyFrame then
		TransmogrifyFrame:SetScale(Semi_FrameNames_Scale);
	end
	if VoidStorageFrame then
		VoidStorageFrame:SetScale(Semi_FrameNames_Scale)
	end
	if PetJournalParent then
		PetJournalParent:SetScale(Semi_FrameNames_Scale)
	end
	if AchievementFrame then
		AchievementFrame:SetScale(Semi_FrameNames_Scale)
	end
	if ItemSocketingFrame then
		ItemSocketingFrame:SetScale(Semi_FrameNames_Scale)
	end
	--if GuildRegistrarFrame then
	--	GuildRegistrarFrame:SetScale(Semi_FrameNames_Scale)
	--end
	--if PetitionFrame then
	--	PetitionFrame:SetScale(Semi_FrameNames_Scale)
	--end
	
	--New Garrison Frames --
	for i=1,7 do
		if Semi_Garrison_FrameNames[i] then
			Semi_Garrison_FrameNames[i]:SetScale(Semi_FrameNames_Scale);
		end
	end
	
	if QuestChoiceFrame then
		QuestChoiceFrame:SetScale(Semi_FrameNames_Scale);
	end
	
	Semi_Run_Scale_Reset = false;
end

function Semi_CollectionsJournal_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_CollectionsJournal_Scale = PassedValueFromSliderOrEvent;
	if CollectionsJournal ~= nil then
		CollectionsJournal:SetScale(Semi_CollectionsJournal_Scale);
	end
	
end
function Semi_CalendarFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_CalendarFrame_Scale = PassedValueFromSliderOrEvent;
	if CalendarFrame ~= nil  then
		CalendarFrame:SetScale(Semi_CalendarFrame_Scale);
	end
end

function Semi_WorldMapFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_WorldMapFrame_Scale = PassedValueFromSliderOrEvent;
	WorldMapFrame:SetScale(Semi_WorldMapFrame_Scale);
end

hooksecurefunc("MacroFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		MacroFrame:SetScale(Semi_FrameNames_Scale)
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("TradeSkillFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		TradeSkillFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

--[[
hooksecurefunc("LookingForGuildFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		LookingForGuildFrame:SetScale(Semi_FrameNames_Scale)
	else
		Semi_Run_Scale_Reset = true;
	end
end);
]]

hooksecurefunc("GuildFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		GuildFrame:SetScale(Semi_FrameNames_Scale)
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("InspectFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		InspectFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("ClassTrainerFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		ClassTrainerFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("ArchaeologyFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		ArchaeologyFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("TalentFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		PlayerTalentFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);
--new stuff follows
hooksecurefunc("EncounterJournal_LoadUI", function()
	if (not InCombatLockdown()) then
		EncounterJournal:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("ItemUpgrade_LoadUI", function()
	if (not InCombatLockdown()) then
		ItemUpgradeFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("VoidStorage_LoadUI", function()
	if (not InCombatLockdown()) then
		VoidStorageFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("AchievementFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		AchievementFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("ItemSocketingFrame_LoadUI", function()
	if (not InCombatLockdown()) then
		ItemSocketingFrame:SetScale(Semi_FrameNames_Scale);
	else
		Semi_Run_Scale_Reset = true;
	end
end);

hooksecurefunc("Garrison_LoadUI", function()
	if (not InCombatLockdown()) then
		GarrisonBuildingFrame:SetScale(Semi_FrameNames_Scale);
		GarrisonMissionFrame:SetScale(Semi_FrameNames_Scale);
		GarrisonLandingPage:SetScale(Semi_FrameNames_Scale);
		GarrisonMonumentFrame:SetScale(Semi_FrameNames_Scale);
		GarrisonRecruiterFrame:SetScale(Semi_FrameNames_Scale);
		GarrisonRecruitSelectFrame:SetScale(Semi_FrameNames_Scale);
		GarrisonCapacitiveDisplayFrame:SetScale(Semi_FrameNames_Scale);
	end
end);
