
function Semi_ObjectiveFrame_Slider()
	CreateFrame("Slider", "SemiObjectiveFrameScaleSlider", Semi_ScaleOptions, "OptionsSliderTemplate")
	SemiObjectiveFrameScaleSlider:ClearAllPoints();
	if IsAddOnLoaded("Semi_Extra_Scaling") then
		SemiObjectiveFrameScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -350);
	else
		SemiObjectiveFrameScaleSlider:SetPoint("TOP", Semi_ScaleOptions, "TOP", 0, -200);
	end
	SemiObjectiveFrameScaleSlider:SetMinMaxValues(0.25, 2.5);
	SemiObjectiveFrameScaleSlider:SetValueStep(0.05);
	SemiObjectiveFrameScaleSlider:SetValue(Semi_ObjectiveFrame_Scale);
	SemiObjectiveFrameScaleSlider:SetScript("OnValueChanged", function (self, value)
									new_value = semi_round(value, 2);
									self:SetValue(new_value);
									Semi_ObjectiveFrame_Scale_On_Change(new_value);
									GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 10);
									GameTooltip:SetText(new_value);
									_G[SemiObjectiveFrameScaleSlider:GetName().."Text"]:SetText("Objective Frame:  "..Semi_ObjectiveFrame_Scale);
									GameTooltip:Show();
									GameTooltip:FadeOut();
								end)
	_G[SemiObjectiveFrameScaleSlider:GetName().."Low"]:SetText("0.25");
	_G[SemiObjectiveFrameScaleSlider:GetName().."High"]:SetText("2.5");
	_G[SemiObjectiveFrameScaleSlider:GetName().."Text"]:SetText("Objective Frame:  "..Semi_ObjectiveFrame_Scale);
	SemiObjectiveFrameScaleSlider:Show();
end

function Semi_ObjectiveFrame_Scale_On_Change(PassedValueFromSliderOrEvent)
	Semi_ObjectiveFrame_Scale = PassedValueFromSliderOrEvent;
	SemiObjectiveFrameDragButton:SetScale(Semi_ObjectiveFrame_Scale);
	_G['ObjectiveTrackerFrame']:SetScale(Semi_ObjectiveFrame_Scale);
end

function Semi_LinkObjectiveFrameToDragButton()
	if (not InCombatLockdown()) then
		_G['ObjectiveTrackerFrame']:SetScale(Semi_ObjectiveFrame_Scale);
		SemiObjectiveFrameDragButton:SetScale(Semi_ObjectiveFrame_Scale);
		_G['ObjectiveTrackerFrame']:ClearAllPoints();	
		_G['ObjectiveTrackerFrame']:SetPoint("TOPLEFT", SemiObjectiveFrameDragButton, "TOPLEFT", 25, 0);
		_G['ObjectiveTrackerFrame']:SetMovable(true);
		_G['ObjectiveTrackerFrame']:SetUserPlaced(true);
		SemiObjectiveFrameDragButton:SetAlpha(0);
		SemiObjectiveFrameDragButton:SetFrameStrata("Low");
		_G['ObjectiveTrackerFrame']:SetHeight(Semi_Objective_Frame_Height);
	end
end

function Semi_ObjectiveFrame_Change_Height(PassedValueFromEditBoxOrEvent)
	Semi_Objective_Frame_Height = PassedValueFromEditBoxOrEvent;
	if (not InCombatLockdown()) then
		_G['ObjectiveTrackerFrame']:SetHeight(Semi_Objective_Frame_Height);
	end
end

function Semi_ObjectiveFrame_EditBox_Action(self)
	local number = self:GetNumber();
	self:SetText("");
	if number == "" or number == " " then
		return;
	end
	
	if number < 100 then
		print("Height can not be less than 100");
	else
		Semi_ObjectiveFrame_Change_Height(number);
		print("Objective Frame Height is now "..number);
		self:ClearFocus();
	end
end

function Semi_Move_Objective_Frame_Config(self)
	self:SetAutoFocus(false);
	self:SetText("Objective Frame Height: "..Semi_Objective_Frame_Height)
	self:SetCursorPosition(0);
end
